searchData={"items":[{"type":"module","title":"BlueHeron","doc":"BLE","ref":"BlueHeron.html"},{"type":"module","title":"BlueHeron.ACL","doc":"> HCI ACL Data packets are used to exchange data between the Host and Controller\n\nBluetooth Spec v5.2, vol 4, Part E, 5.4.2","ref":"BlueHeron.ACL.html"},{"type":"function","title":"BlueHeron.ACL.deserialize/1","doc":"","ref":"BlueHeron.ACL.html#deserialize/1"},{"type":"function","title":"BlueHeron.ACL.serialize/1","doc":"","ref":"BlueHeron.ACL.html#serialize/1"},{"type":"module","title":"BlueHeron.ACLBuffer","doc":"simple fifo buffer implementation that handles sending ACL packets synchronously without blocking","ref":"BlueHeron.ACLBuffer.html"},{"type":"function","title":"BlueHeron.ACLBuffer.buffer/1","doc":"queue up a message for output","ref":"BlueHeron.ACLBuffer.html#buffer/1"},{"type":"function","title":"BlueHeron.ACLBuffer.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"BlueHeron.ACLBuffer.html#child_spec/1"},{"type":"function","title":"BlueHeron.ACLBuffer.start_link/1","doc":"","ref":"BlueHeron.ACLBuffer.html#start_link/1"},{"type":"module","title":"BlueHeron.ATT","doc":"Functions for serializing and deserializing ATT data","ref":"BlueHeron.ATT.html"},{"type":"function","title":"BlueHeron.ATT.deserialize/2","doc":"Takes binary data and returns a struct","ref":"BlueHeron.ATT.html#deserialize/2"},{"type":"function","title":"BlueHeron.ATT.serialize/1","doc":"Takes a struct and returns binary data","ref":"BlueHeron.ATT.html#serialize/1"},{"type":"module","title":"BlueHeron.ATT.ErrorResponse","doc":"> The ATT_ERROR_RSP PDU is used to state that a given request cannot be performed,\n> and to provide the reason.\n\nBluetooth Spec v5.2, vol 3, Part F, 3.4.1.1","ref":"BlueHeron.ATT.ErrorResponse.html"},{"type":"function","title":"BlueHeron.ATT.ErrorResponse.deserialize/1","doc":"","ref":"BlueHeron.ATT.ErrorResponse.html#deserialize/1"},{"type":"function","title":"BlueHeron.ATT.ErrorResponse.serialize/1","doc":"","ref":"BlueHeron.ATT.ErrorResponse.html#serialize/1"},{"type":"module","title":"BlueHeron.ATT.ExchangeMTURequest","doc":"> The ATT_EXCHANGE_MTU_REQ PDU is used by the client to inform the server of the\n> client’s maximum receive MTU size and request the server to respond with its maximum\n> receive MTU size.\n\nBluetooth Spec v5.2, vol 3, Part F, 3.4.2.1","ref":"BlueHeron.ATT.ExchangeMTURequest.html"},{"type":"function","title":"BlueHeron.ATT.ExchangeMTURequest.deserialize/1","doc":"","ref":"BlueHeron.ATT.ExchangeMTURequest.html#deserialize/1"},{"type":"function","title":"BlueHeron.ATT.ExchangeMTURequest.serialize/1","doc":"","ref":"BlueHeron.ATT.ExchangeMTURequest.html#serialize/1"},{"type":"type","title":"BlueHeron.ATT.ExchangeMTURequest.t/0","doc":"","ref":"BlueHeron.ATT.ExchangeMTURequest.html#t:t/0"},{"type":"module","title":"BlueHeron.ATT.ExchangeMTUResponse","doc":"> The ATT_EXCHANGE_MTU_RSP PDU is sent in reply to a received\n> ATT_EXCHANGE_MTU_REQ PDU.\n\nBluetooth Spec v5.2, vol 3, Part F, 3.4.2.2","ref":"BlueHeron.ATT.ExchangeMTUResponse.html"},{"type":"function","title":"BlueHeron.ATT.ExchangeMTUResponse.deserialize/1","doc":"","ref":"BlueHeron.ATT.ExchangeMTUResponse.html#deserialize/1"},{"type":"function","title":"BlueHeron.ATT.ExchangeMTUResponse.serialize/1","doc":"","ref":"BlueHeron.ATT.ExchangeMTUResponse.html#serialize/1"},{"type":"module","title":"BlueHeron.ATT.ExecuteWriteRequest","doc":"> The ATT_EXECUTE_WRITE_REQ PDU is used to request the server to write or cancel\n> the write of all the prepared values currently held in the prepare queue from this client.\n> This request shall be handled by the server as an atomic operation\n\nBluetooth Spec v5.2, vol 3, Part F, 3.4.6.3","ref":"BlueHeron.ATT.ExecuteWriteRequest.html"},{"type":"function","title":"BlueHeron.ATT.ExecuteWriteRequest.deserialize/1","doc":"","ref":"BlueHeron.ATT.ExecuteWriteRequest.html#deserialize/1"},{"type":"function","title":"BlueHeron.ATT.ExecuteWriteRequest.serialize/1","doc":"","ref":"BlueHeron.ATT.ExecuteWriteRequest.html#serialize/1"},{"type":"module","title":"BlueHeron.ATT.ExecuteWriteResponse","doc":"> The ATT_EXECUTE_WRITE_RSP PDU is sent in response to a received\n> ATT_EXECUTE_WRITE_REQ PDU.\n\nBluetooth Spec v5.2, vol 3, Part F, 3.4.6.4","ref":"BlueHeron.ATT.ExecuteWriteResponse.html"},{"type":"function","title":"BlueHeron.ATT.ExecuteWriteResponse.deserialize/1","doc":"","ref":"BlueHeron.ATT.ExecuteWriteResponse.html#deserialize/1"},{"type":"function","title":"BlueHeron.ATT.ExecuteWriteResponse.serialize/1","doc":"","ref":"BlueHeron.ATT.ExecuteWriteResponse.html#serialize/1"},{"type":"module","title":"BlueHeron.ATT.FindByTypeValueRequest","doc":"> The ATT_FIND_BY_TYPE_VALUE_RSP PDU is sent in reply to a received\n> ATT_FIND_BY_TYPE_VALUE_REQ PDU and contains information about this server.\n\nBluetooth Spec v5.2, vol 3, Part F, 3.4.3.4","ref":"BlueHeron.ATT.FindByTypeValueRequest.html"},{"type":"function","title":"BlueHeron.ATT.FindByTypeValueRequest.deserialize/1","doc":"","ref":"BlueHeron.ATT.FindByTypeValueRequest.html#deserialize/1"},{"type":"function","title":"BlueHeron.ATT.FindByTypeValueRequest.serialize/1","doc":"","ref":"BlueHeron.ATT.FindByTypeValueRequest.html#serialize/1"},{"type":"module","title":"BlueHeron.ATT.FindByTypeValueResponse","doc":"> The ATT_FIND_BY_TYPE_VALUE_RSP PDU is sent in reply to a received\n> ATT_FIND_BY_TYPE_VALUE_REQ PDU and contains information about this server.\n\nBluetooth Spec v5.2, vol 3, Part F, 3.4.3.4","ref":"BlueHeron.ATT.FindByTypeValueResponse.html"},{"type":"function","title":"BlueHeron.ATT.FindByTypeValueResponse.deserialize/1","doc":"","ref":"BlueHeron.ATT.FindByTypeValueResponse.html#deserialize/1"},{"type":"function","title":"BlueHeron.ATT.FindByTypeValueResponse.serialize/1","doc":"","ref":"BlueHeron.ATT.FindByTypeValueResponse.html#serialize/1"},{"type":"module","title":"BlueHeron.ATT.FindByTypeValueResponse.HandlesInformation","doc":"Strucutured HandleInformation encoder/decoder.","ref":"BlueHeron.ATT.FindByTypeValueResponse.HandlesInformation.html"},{"type":"function","title":"BlueHeron.ATT.FindByTypeValueResponse.HandlesInformation.deserialize/1","doc":"","ref":"BlueHeron.ATT.FindByTypeValueResponse.HandlesInformation.html#deserialize/1"},{"type":"function","title":"BlueHeron.ATT.FindByTypeValueResponse.HandlesInformation.serialize/1","doc":"","ref":"BlueHeron.ATT.FindByTypeValueResponse.HandlesInformation.html#serialize/1"},{"type":"module","title":"BlueHeron.ATT.FindInformationRequest","doc":"> The ATT_FIND_INFORMATION_REQ PDU is used to obtain the mapping of attribute\n> handles with their associated types. This allows a client to discover the list of attributes\n> and their types on a server.\n\nBluetooth Spec v5.2, vol 3, Part F, 3.4.3.1","ref":"BlueHeron.ATT.FindInformationRequest.html"},{"type":"function","title":"BlueHeron.ATT.FindInformationRequest.deserialize/1","doc":"","ref":"BlueHeron.ATT.FindInformationRequest.html#deserialize/1"},{"type":"function","title":"BlueHeron.ATT.FindInformationRequest.serialize/1","doc":"","ref":"BlueHeron.ATT.FindInformationRequest.html#serialize/1"},{"type":"module","title":"BlueHeron.ATT.FindInformationResponse","doc":"> The ATT_FIND_INFORMATION_RSP PDU is sent in reply to a received\n> ATT_FIND_INFORMATION_REQ PDU and contains information about this server.\n\nBluetooth Spec v5.2, vol 3, Part F, 3.4.3.2","ref":"BlueHeron.ATT.FindInformationResponse.html"},{"type":"function","title":"BlueHeron.ATT.FindInformationResponse.deserialize/1","doc":"","ref":"BlueHeron.ATT.FindInformationResponse.html#deserialize/1"},{"type":"function","title":"BlueHeron.ATT.FindInformationResponse.serialize/1","doc":"","ref":"BlueHeron.ATT.FindInformationResponse.html#serialize/1"},{"type":"module","title":"BlueHeron.ATT.FindInformationResponse.InformationData","doc":"Strucutured InformationData encoder/decoder.","ref":"BlueHeron.ATT.FindInformationResponse.InformationData.html"},{"type":"function","title":"BlueHeron.ATT.FindInformationResponse.InformationData.deserialize/1","doc":"","ref":"BlueHeron.ATT.FindInformationResponse.InformationData.html#deserialize/1"},{"type":"function","title":"BlueHeron.ATT.FindInformationResponse.InformationData.serialize/1","doc":"","ref":"BlueHeron.ATT.FindInformationResponse.InformationData.html#serialize/1"},{"type":"module","title":"BlueHeron.ATT.HandleValueConfirmation","doc":"> The ATT_HANDLE_VALUE_CFM PDU is sent in response to a received\n> ATT_HANDLE_VALUE_IND PDU and confirms that the client has received an indication\n> of the given attribute.\n\nBluetooth Spec v5.2, vol 3, Part F, 3.4.7.3","ref":"BlueHeron.ATT.HandleValueConfirmation.html"},{"type":"function","title":"BlueHeron.ATT.HandleValueConfirmation.deserialize/1","doc":"","ref":"BlueHeron.ATT.HandleValueConfirmation.html#deserialize/1"},{"type":"function","title":"BlueHeron.ATT.HandleValueConfirmation.serialize/1","doc":"","ref":"BlueHeron.ATT.HandleValueConfirmation.html#serialize/1"},{"type":"module","title":"BlueHeron.ATT.HandleValueIndication","doc":"> A server can send a notification of an attribute’s value at any time.\n\nBluetooth Spec v5.2, vol 3, Part F, 3.4.7.2","ref":"BlueHeron.ATT.HandleValueIndication.html"},{"type":"function","title":"BlueHeron.ATT.HandleValueIndication.deserialize/1","doc":"","ref":"BlueHeron.ATT.HandleValueIndication.html#deserialize/1"},{"type":"function","title":"BlueHeron.ATT.HandleValueIndication.serialize/1","doc":"","ref":"BlueHeron.ATT.HandleValueIndication.html#serialize/1"},{"type":"module","title":"BlueHeron.ATT.HandleValueNotification","doc":"> A server can send a notification of an attribute’s value at any time.\n\nBluetooth Spec v5.2, vol 3, Part F, 3.4.7.1","ref":"BlueHeron.ATT.HandleValueNotification.html"},{"type":"function","title":"BlueHeron.ATT.HandleValueNotification.deserialize/1","doc":"","ref":"BlueHeron.ATT.HandleValueNotification.html#deserialize/1"},{"type":"function","title":"BlueHeron.ATT.HandleValueNotification.serialize/1","doc":"","ref":"BlueHeron.ATT.HandleValueNotification.html#serialize/1"},{"type":"type","title":"BlueHeron.ATT.HandleValueNotification.t/0","doc":"","ref":"BlueHeron.ATT.HandleValueNotification.html#t:t/0"},{"type":"module","title":"BlueHeron.ATT.PrepareWriteRequest","doc":"> The ATT_PREPARE_WRITE_REQ PDU is used to request the server to prepare\n> to write the value of an attribute.\n\nBluetooth Spec v5.2, vol 3, Part F, 3.4.6.1","ref":"BlueHeron.ATT.PrepareWriteRequest.html"},{"type":"function","title":"BlueHeron.ATT.PrepareWriteRequest.deserialize/1","doc":"","ref":"BlueHeron.ATT.PrepareWriteRequest.html#deserialize/1"},{"type":"function","title":"BlueHeron.ATT.PrepareWriteRequest.serialize/1","doc":"","ref":"BlueHeron.ATT.PrepareWriteRequest.html#serialize/1"},{"type":"module","title":"BlueHeron.ATT.PrepareWriteResponse","doc":"> The ATT_PREPARE_WRITE_RSP PDU is sent in response to a received\n> ATT_PREPARE_WRITE_REQ PDU and acknowledges that the value has been\n> successfully received and placed in the prepare write queue.\n\nBluetooth Spec v5.2, vol 3, Part F, 3.4.6.2","ref":"BlueHeron.ATT.PrepareWriteResponse.html"},{"type":"function","title":"BlueHeron.ATT.PrepareWriteResponse.deserialize/1","doc":"","ref":"BlueHeron.ATT.PrepareWriteResponse.html#deserialize/1"},{"type":"function","title":"BlueHeron.ATT.PrepareWriteResponse.serialize/1","doc":"","ref":"BlueHeron.ATT.PrepareWriteResponse.html#serialize/1"},{"type":"module","title":"BlueHeron.ATT.ReadBlobRequest","doc":"> The ATT_READ_BLOB_REQ PDU is used to request the server to read part of the\n> value of an attribute at a given offset and return a specific part of the value in an\n> ATT_READ_BLOB_RSP PDU.\n\nBluetooth Spec v5.2, vol 3, Part F, 3.4.4.5","ref":"BlueHeron.ATT.ReadBlobRequest.html"},{"type":"function","title":"BlueHeron.ATT.ReadBlobRequest.deserialize/1","doc":"","ref":"BlueHeron.ATT.ReadBlobRequest.html#deserialize/1"},{"type":"function","title":"BlueHeron.ATT.ReadBlobRequest.serialize/1","doc":"","ref":"BlueHeron.ATT.ReadBlobRequest.html#serialize/1"},{"type":"module","title":"BlueHeron.ATT.ReadBlobResponse","doc":"> The ATT_READ_BLOB_RSP PDU is sent in reply to a received\n> ATT_READ_BLOB_REQ PDU and contains part of the value of the attribute that has\n> been read\n\nBluetooth Spec v5.2, vol 3, Part F, 3.4.4.6","ref":"BlueHeron.ATT.ReadBlobResponse.html"},{"type":"function","title":"BlueHeron.ATT.ReadBlobResponse.deserialize/1","doc":"","ref":"BlueHeron.ATT.ReadBlobResponse.html#deserialize/1"},{"type":"function","title":"BlueHeron.ATT.ReadBlobResponse.serialize/1","doc":"","ref":"BlueHeron.ATT.ReadBlobResponse.html#serialize/1"},{"type":"module","title":"BlueHeron.ATT.ReadByGroupTypeRequest","doc":"> The ATT_READ_BY_GROUP_TYPE_REQ PDU is used to obtain the values of\n> attributes where the attribute type is known, the type of a grouping attribute as defined\n> by a higher layer specification, but the handle is not known.\n\nBluetooth Spec v5.2, vol 3, Part F, 3.4.4.9","ref":"BlueHeron.ATT.ReadByGroupTypeRequest.html"},{"type":"function","title":"BlueHeron.ATT.ReadByGroupTypeRequest.deserialize/1","doc":"","ref":"BlueHeron.ATT.ReadByGroupTypeRequest.html#deserialize/1"},{"type":"function","title":"BlueHeron.ATT.ReadByGroupTypeRequest.serialize/1","doc":"","ref":"BlueHeron.ATT.ReadByGroupTypeRequest.html#serialize/1"},{"type":"module","title":"BlueHeron.ATT.ReadByGroupTypeResponse","doc":"> The ATT_READ_BY_GROUP_TYPE_RSP PDU is sent in reply to a received\n> ATT_READ_BY_GROUP_TYPE_REQ PDU and contains the handles and values of the\n> attributes that have been read\n\nBluetooth Spec v5.2, vol 3, Part F, 3.4.4.10","ref":"BlueHeron.ATT.ReadByGroupTypeResponse.html"},{"type":"function","title":"BlueHeron.ATT.ReadByGroupTypeResponse.deserialize/1","doc":"","ref":"BlueHeron.ATT.ReadByGroupTypeResponse.html#deserialize/1"},{"type":"function","title":"BlueHeron.ATT.ReadByGroupTypeResponse.serialize/1","doc":"","ref":"BlueHeron.ATT.ReadByGroupTypeResponse.html#serialize/1"},{"type":"module","title":"BlueHeron.ATT.ReadByGroupTypeResponse.AttributeData","doc":"Strucutured AttributeData encoder/decoder.","ref":"BlueHeron.ATT.ReadByGroupTypeResponse.AttributeData.html"},{"type":"function","title":"BlueHeron.ATT.ReadByGroupTypeResponse.AttributeData.deserialize/1","doc":"","ref":"BlueHeron.ATT.ReadByGroupTypeResponse.AttributeData.html#deserialize/1"},{"type":"function","title":"BlueHeron.ATT.ReadByGroupTypeResponse.AttributeData.serialize/1","doc":"","ref":"BlueHeron.ATT.ReadByGroupTypeResponse.AttributeData.html#serialize/1"},{"type":"module","title":"BlueHeron.ATT.ReadByTypeRequest","doc":"> The ATT_READ_BY_TYPE_REQ PDU is used to obtain the values of attributes where\n> the attribute type is known but the handle is not known.\n\nBluetooth Spec v5.2, vol 3, Part F, 3.4.4.1","ref":"BlueHeron.ATT.ReadByTypeRequest.html"},{"type":"function","title":"BlueHeron.ATT.ReadByTypeRequest.deserialize/1","doc":"","ref":"BlueHeron.ATT.ReadByTypeRequest.html#deserialize/1"},{"type":"function","title":"BlueHeron.ATT.ReadByTypeRequest.serialize/1","doc":"","ref":"BlueHeron.ATT.ReadByTypeRequest.html#serialize/1"},{"type":"module","title":"BlueHeron.ATT.ReadByTypeResponse","doc":"> The ATT_READ_BY_TYPE_RSP PDU is sent in reply to a received\n> ATT_READ_BY_TYPE_REQ PDU and contains the handles and values of the attributes\n> that have been read.\n\nBluetooth Spec v5.2, vol 3, Part F, 3.4.4.2","ref":"BlueHeron.ATT.ReadByTypeResponse.html"},{"type":"function","title":"BlueHeron.ATT.ReadByTypeResponse.deserialize/1","doc":"","ref":"BlueHeron.ATT.ReadByTypeResponse.html#deserialize/1"},{"type":"function","title":"BlueHeron.ATT.ReadByTypeResponse.serialize/1","doc":"","ref":"BlueHeron.ATT.ReadByTypeResponse.html#serialize/1"},{"type":"module","title":"BlueHeron.ATT.ReadByTypeResponse.AttributeData","doc":"Structure containing decoders and encoders for the Attribute Data","ref":"BlueHeron.ATT.ReadByTypeResponse.AttributeData.html"},{"type":"function","title":"BlueHeron.ATT.ReadByTypeResponse.AttributeData.deserialize/1","doc":"","ref":"BlueHeron.ATT.ReadByTypeResponse.AttributeData.html#deserialize/1"},{"type":"function","title":"BlueHeron.ATT.ReadByTypeResponse.AttributeData.serialize/1","doc":"","ref":"BlueHeron.ATT.ReadByTypeResponse.AttributeData.html#serialize/1"},{"type":"module","title":"BlueHeron.ATT.ReadRequest","doc":"> The ATT_READ_REQ PDU is used to request the server to read the value of an\n> attribute and return its value in an ATT_READ_RSP PDU.\n\nBluetooth Spec v5.2, vol 3, Part F, 3.4.4.3","ref":"BlueHeron.ATT.ReadRequest.html"},{"type":"function","title":"BlueHeron.ATT.ReadRequest.deserialize/1","doc":"","ref":"BlueHeron.ATT.ReadRequest.html#deserialize/1"},{"type":"function","title":"BlueHeron.ATT.ReadRequest.serialize/1","doc":"","ref":"BlueHeron.ATT.ReadRequest.html#serialize/1"},{"type":"module","title":"BlueHeron.ATT.ReadResponse","doc":"> The ATT_READ_RSP PDU is sent in reply to a received Read Request and contains\n> the value of the attribute that has been read.\n\nBluetooth Spec v5.2, vol 3, Part F, 3.4.4.4","ref":"BlueHeron.ATT.ReadResponse.html"},{"type":"function","title":"BlueHeron.ATT.ReadResponse.deserialize/1","doc":"","ref":"BlueHeron.ATT.ReadResponse.html#deserialize/1"},{"type":"function","title":"BlueHeron.ATT.ReadResponse.serialize/1","doc":"","ref":"BlueHeron.ATT.ReadResponse.html#serialize/1"},{"type":"module","title":"BlueHeron.ATT.WriteCommand","doc":"> The ATT_WRITE_CMD PDU is used to request the server to write the value of an\n> attribute, typically into a control-point attribute.\n\nBluetooth Spec v5.2, vol 3, Part F, 3.4.5.3","ref":"BlueHeron.ATT.WriteCommand.html"},{"type":"function","title":"BlueHeron.ATT.WriteCommand.deserialize/1","doc":"","ref":"BlueHeron.ATT.WriteCommand.html#deserialize/1"},{"type":"function","title":"BlueHeron.ATT.WriteCommand.serialize/1","doc":"","ref":"BlueHeron.ATT.WriteCommand.html#serialize/1"},{"type":"module","title":"BlueHeron.ATT.WriteRequest","doc":"> The ATT_WRITE_REQ PDU is used to request the server to write the value of an\n> attribute and acknowledge that this has been achieved in an ATT_WRITE_RSP PDU.\n\nBluetooth Spec v5.2, vol 3, Part F, 3.4.5.1","ref":"BlueHeron.ATT.WriteRequest.html"},{"type":"function","title":"BlueHeron.ATT.WriteRequest.deserialize/1","doc":"","ref":"BlueHeron.ATT.WriteRequest.html#deserialize/1"},{"type":"function","title":"BlueHeron.ATT.WriteRequest.serialize/1","doc":"","ref":"BlueHeron.ATT.WriteRequest.html#serialize/1"},{"type":"module","title":"BlueHeron.ATT.WriteResponse","doc":"> The ATT_WRITE_RSP PDU is sent in reply to a valid ATT_WRITE_REQ PDU and\n> acknowledges that the attribute has been successfully written.\n\nBluetooth Spec v5.2, vol 3, Part F, 3.4.5.2","ref":"BlueHeron.ATT.WriteResponse.html"},{"type":"function","title":"BlueHeron.ATT.WriteResponse.deserialize/1","doc":"","ref":"BlueHeron.ATT.WriteResponse.html#deserialize/1"},{"type":"function","title":"BlueHeron.ATT.WriteResponse.serialize/1","doc":"","ref":"BlueHeron.ATT.WriteResponse.html#serialize/1"},{"type":"module","title":"BlueHeron.Address","doc":"Helper struct for working with BLE Addresses.","ref":"BlueHeron.Address.html"},{"type":"function","title":"BlueHeron.Address.parse/1","doc":"Parses an Address from a colon delimited BLE address string\nExamples:\n\n    iex> BlueHeron.Address.parse(\"A4:C1:38:A0:49:8B\")\n    #Address \n\n    iex> BlueHeron.Address.parse(0xA4C138A0498B)\n    #Address \n\n    iex> BlueHeron.Address.parse(181149785672075)\n    #Address \n\n    iex> BlueHeron.Address.parse(<<0xA4, 0xC1, 0x38, 0xA0, 0x49, 0x8B>>)\n    #Address \n\n    iex> BlueHeron.Address.parse(<<164, 193, 56, 160, 73, 139>>)\n    #Address","ref":"BlueHeron.Address.html#parse/1"},{"type":"function","title":"BlueHeron.Address.serialize/1","doc":"","ref":"BlueHeron.Address.html#serialize/1"},{"type":"module","title":"BlueHeron.AdvertisingData","doc":"Handles building AD structures for AdvertiseingData and ScanResponseData","ref":"BlueHeron.AdvertisingData.html"},{"type":"function","title":"BlueHeron.AdvertisingData.complete_list_of_service_uuids/1","doc":"Compose list of UUIDs AD structure\n\n    iex()> BlueHeron.AdvertisingData.complete_list_of_service_uuids([0x12, 0xab])\n    <<5, 3, 171, 0, 18, 0>>","ref":"BlueHeron.AdvertisingData.html#complete_list_of_service_uuids/1"},{"type":"function","title":"BlueHeron.AdvertisingData.complete_name/1","doc":"Compose CompleteName AD from a string\n\n    iex()> BlueHeron.AdvertisingData.complete_name(\"nerves\")\n    <<0x7, 0x9, 0x6E, 0x65, 0x72, 0x76, 0x65, 0x73>>","ref":"BlueHeron.AdvertisingData.html#complete_name/1"},{"type":"function","title":"BlueHeron.AdvertisingData.flags/1","doc":"Compose flags AD from a list\n\n    iex()> BlueHeron.AdvertisingData.flags([le_general_discoverable_mode: true, br_edr_not_supported: true])\n    <<2, 1, 6>>","ref":"BlueHeron.AdvertisingData.html#flags/1"},{"type":"function","title":"BlueHeron.AdvertisingData.incomplete_list_of_service_uuids/1","doc":"Compose list of UUIDs AD structure\n\n    iex()> BlueHeron.AdvertisingData.incomplete_list_of_service_uuids([0x12, 0xab])\n    <<5, 2, 171, 0, 18, 0>>\n\n    iex()> BlueHeron.AdvertisingData.incomplete_list_of_service_uuids([0xF018E00E0ECE45B09617B744833D89BA])\n    <<17, 6, 186, 137, 61, 131, 68, 183, 23, 150, 176, 69, 206, 14, 14, 224, 24,\n      240>>","ref":"BlueHeron.AdvertisingData.html#incomplete_list_of_service_uuids/1"},{"type":"function","title":"BlueHeron.AdvertisingData.manufacturer_specific_data/1","doc":"Compose ManufacturerSpecificData AD. Company ID must be encoded in `Value`.\n\n    iex()> ibeacon = BlueHeron.AdvertisingData.IBeacon.new(<<0xF018E00E0ECE45B09617B744833D89BA>>, 1, 2, -50)\n    <<76, 0, 2, 21, 186, 0, 1, 0, 2, 206>>\n    iex()> BlueHeron.AdvertisingData.manufacturer_specific_data(ibeacon)\n    <<11, 255, 76, 0, 2, 21, 186, 0, 1, 0, 2, 206>>","ref":"BlueHeron.AdvertisingData.html#manufacturer_specific_data/1"},{"type":"function","title":"BlueHeron.AdvertisingData.short_name/1","doc":"Compose ShortName AD from a string\n\n    iex()> BlueHeron.AdvertisingData.short_name(\"nerves\")\n    <<0x7, 0x8, 0x6E, 0x65, 0x72, 0x76, 0x65, 0x73>>","ref":"BlueHeron.AdvertisingData.html#short_name/1"},{"type":"type","title":"BlueHeron.AdvertisingData.ad/0","doc":"","ref":"BlueHeron.AdvertisingData.html#t:ad/0"},{"type":"type","title":"BlueHeron.AdvertisingData.flag/0","doc":"","ref":"BlueHeron.AdvertisingData.html#t:flag/0"},{"type":"module","title":"BlueHeron.AdvertisingData.IBeacon","doc":"Handles creating Apple IBeacon packets","ref":"BlueHeron.AdvertisingData.IBeacon.html"},{"type":"function","title":"BlueHeron.AdvertisingData.IBeacon.new/4","doc":"Create a IBeacon packet.\n\n* UUID - 128 bit binary\n* major and minor - a 16 bit identifier\n* tx power - calibrated signal strength measured 1 meter away from the device. Helps estimate proximity.","ref":"BlueHeron.AdvertisingData.IBeacon.html#new/4"},{"type":"module","title":"BlueHeron.AssignedNumbers.CompanyIdentifiers","doc":"> Company identifiers are unique numbers assigned by the Bluetooth SIG to member companies\n> requesting one.\n\nReference: https://www.bluetooth.com/specifications/assigned-numbers/company-identifiers","ref":"BlueHeron.AssignedNumbers.CompanyIdentifiers.html"},{"type":"function","title":"BlueHeron.AssignedNumbers.CompanyIdentifiers.description/1","doc":"Returns the description associated with `id`.","ref":"BlueHeron.AssignedNumbers.CompanyIdentifiers.html#description/1"},{"type":"function","title":"BlueHeron.AssignedNumbers.CompanyIdentifiers.id/1","doc":"Returns the ID associated with `description`.","ref":"BlueHeron.AssignedNumbers.CompanyIdentifiers.html#id/1"},{"type":"macro","title":"BlueHeron.AssignedNumbers.CompanyIdentifiers.ids/0","doc":"Returns a list of all Company Identifier ids.","ref":"BlueHeron.AssignedNumbers.CompanyIdentifiers.html#ids/0"},{"type":"module","title":"BlueHeron.AssignedNumbers.GenericAccessProfile","doc":"> Assigned numbers are used in GAP for inquiry response, EIR data type values,\n> manufacturer-specific data, advertising data, low energy UUIDs and appearance characteristics,\n> and class of device.\n\nReference: https://www.bluetooth.com/specifications/assigned-numbers/generic-access-profile","ref":"BlueHeron.AssignedNumbers.GenericAccessProfile.html"},{"type":"macro","title":"BlueHeron.AssignedNumbers.GenericAccessProfile.description/1","doc":"Returns the description associated with `id`.","ref":"BlueHeron.AssignedNumbers.GenericAccessProfile.html#description/1"},{"type":"macro","title":"BlueHeron.AssignedNumbers.GenericAccessProfile.id/1","doc":"Returns the ID associated with `description`.","ref":"BlueHeron.AssignedNumbers.GenericAccessProfile.html#id/1"},{"type":"macro","title":"BlueHeron.AssignedNumbers.GenericAccessProfile.ids/0","doc":"Returns a list of all Generic Access Profile Data Type Values.","ref":"BlueHeron.AssignedNumbers.GenericAccessProfile.html#ids/0"},{"type":"module","title":"BlueHeron.Broadcaster","doc":"Handles Advertisement and Broadcasting","ref":"BlueHeron.Broadcaster.html"},{"type":"module","title":"Advertisement Data and Scan Response Data - BlueHeron.Broadcaster","doc":"both `set_advertising_data` and `set_scan_response_data` take the same binary\ndata as an argument. The format is called `AdvertisingData` or `AD` for short in\nthe official BLE spec. The format is\n\n  < >\n\nWhere `param` can be one of many values defined in the official BLE spec suplement, and each `param`\nhas it's own data. Both params have a hard limit of 31 bytes total.","ref":"BlueHeron.Broadcaster.html#module-advertisement-data-and-scan-response-data"},{"type":"function","title":"BlueHeron.Broadcaster.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"BlueHeron.Broadcaster.html#child_spec/1"},{"type":"function","title":"BlueHeron.Broadcaster.set_advertising_data/1","doc":"Sets Advertising Data for a peripheral.\nMust be called **before** `start_advertising` or **after** `stop_advertising`.\n\nsee [Vol 3] Part C, Section 11 of the BLE core specification.\nAdditionally see: Core Specification Supplement, Part A, Data Types Specification","ref":"BlueHeron.Broadcaster.html#set_advertising_data/1"},{"type":"function","title":"BlueHeron.Broadcaster.set_advertising_parameters/1","doc":"Sets Advertising Parameters for a peripheral.\nMust be called **before** `start_advertising` or **after** `stop_advertising`.\n\nsee [Vol 3] Part C, Section 11 of the BLE core specification.\nAdditionally see: Core Specification Supplement, Part A, Data Types Specification","ref":"BlueHeron.Broadcaster.html#set_advertising_parameters/1"},{"type":"function","title":"BlueHeron.Broadcaster.set_scan_response_data/1","doc":"Sets Scan Response Data for a peripheral.\nMust be called **before** `start_advertising` or **after** `stop_advertising`.\n\nsee [Vol 3] Part C, Section 11 of the BLE core specification.\nAdditionally see: Core Specification Supplement, Part A, Data Types Specification","ref":"BlueHeron.Broadcaster.html#set_scan_response_data/1"},{"type":"function","title":"BlueHeron.Broadcaster.start_advertising/0","doc":"Enable advertisement","ref":"BlueHeron.Broadcaster.html#start_advertising/0"},{"type":"function","title":"BlueHeron.Broadcaster.stop_advertising/0","doc":"Disable advertisement","ref":"BlueHeron.Broadcaster.html#stop_advertising/0"},{"type":"module","title":"BlueHeron.DataType.ManufacturerData","doc":"> The Manufacturer Specific data type is used for manufacturer specific data.\n\nReference: Core Specification Supplement, Part A, section 1.4.1\n\nModules under the `BlueHeron.ManufacturerData` scope should implement the\n`BlueHeron.ManufacturerDataBehaviour` and `BlueHeron.Serializable` behaviours.","ref":"BlueHeron.DataType.ManufacturerData.html"},{"type":"function","title":"BlueHeron.DataType.ManufacturerData.deserialize/1","doc":"Deserialize a manufacturer data binary.","ref":"BlueHeron.DataType.ManufacturerData.html#deserialize/1"},{"type":"function","title":"BlueHeron.DataType.ManufacturerData.modules/0","doc":"Returns a list of implementation modules.","ref":"BlueHeron.DataType.ManufacturerData.html#modules/0"},{"type":"function","title":"BlueHeron.DataType.ManufacturerData.serialize/1","doc":"Serializes manufacturer data.","ref":"BlueHeron.DataType.ManufacturerData.html#serialize/1"},{"type":"module","title":"BlueHeron.DataType.ManufacturerData.Apple","doc":"Serialization module for Apple.","ref":"BlueHeron.DataType.ManufacturerData.Apple.html"},{"type":"module","title":"iBeacon - BlueHeron.DataType.ManufacturerData.Apple","doc":"Reference: https://en.wikipedia.org/wiki/IBeacon#Packet_Structure_Byte_Map","ref":"BlueHeron.DataType.ManufacturerData.Apple.html#module-ibeacon"},{"type":"function","title":"BlueHeron.DataType.ManufacturerData.Apple.company/0","doc":"Returns the Company Identifier description associated with this module.\n\n    iex> company()\n    \"Apple, Inc.\"","ref":"BlueHeron.DataType.ManufacturerData.Apple.html#company/0"},{"type":"function","title":"BlueHeron.DataType.ManufacturerData.Apple.deserialize/1","doc":"iex> deserialize(<<2, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 0, 1, 0, 2, 3>>)\n    {:ok, {\"iBeacon\", %{major: 1, minor: 2, tx_power: 3, uuid: 4}}}\n\n    iex> deserialize(<<2, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 0, 1, 0, 2>>)\n    {:error, <<2, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 0, 1, 0, 2>>}","ref":"BlueHeron.DataType.ManufacturerData.Apple.html#deserialize/1"},{"type":"function","title":"BlueHeron.DataType.ManufacturerData.Apple.ibeacon_identifier/0","doc":"Returns the iBeacon identifier.\n\n    iex> ibeacon_identifier()\n    0x02","ref":"BlueHeron.DataType.ManufacturerData.Apple.html#ibeacon_identifier/0"},{"type":"function","title":"BlueHeron.DataType.ManufacturerData.Apple.ibeacon_length/0","doc":"Returns the length of the data following the length byte.\n\n    iex> ibeacon_length()\n    0x15","ref":"BlueHeron.DataType.ManufacturerData.Apple.html#ibeacon_length/0"},{"type":"function","title":"BlueHeron.DataType.ManufacturerData.Apple.serialize/1","doc":"iex> serialize({\"iBeacon\", %{major: 1, minor: 2, tx_power: 3, uuid: 4}})\n    {:ok, <<2, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 0, 1, 0, 2, 3>>}\n\n    iex> serialize({\"iBeacon\", %{major: 1, minor: 2, tx_power: 3}})\n    :error\n\n    iex> serialize(false)\n    :error","ref":"BlueHeron.DataType.ManufacturerData.Apple.html#serialize/1"},{"type":"module","title":"BlueHeron.DataType.ServiceData","doc":"> The Service Data data type consists of a service UUID with the data associated with that\n> service.\n\nReference: Core Specification Supplement, Part A, section 1.11.1","ref":"BlueHeron.DataType.ServiceData.html"},{"type":"function","title":"BlueHeron.DataType.ServiceData.deserialize/1","doc":"Deserialize a service data binary.\n\n    iex> deserialize(<<32, 1, 2, 3, 4, 5, 6>>)\n    {:ok, {\"Service Data - 32-bit UUID\", %{data: <<5, 6>>, uuid: 67305985}}}","ref":"BlueHeron.DataType.ServiceData.html#deserialize/1"},{"type":"function","title":"BlueHeron.DataType.ServiceData.gap_descriptions/0","doc":"Returns the three GAP descriptions encompassed by service data.","ref":"BlueHeron.DataType.ServiceData.html#gap_descriptions/0"},{"type":"function","title":"BlueHeron.DataType.ServiceData.serialize/1","doc":"iex> serialize({\"Service Data - 32-bit UUID\", %{data: <<5, 6>>, uuid: 67305985}})\n    {:ok, <<32, 1, 2, 3, 4, 5, 6>>}","ref":"BlueHeron.DataType.ServiceData.html#serialize/1"},{"type":"module","title":"BlueHeron.ErrorCode","doc":"Defines all error codes and functions to map between error code and name.\n\n> When a command fails, or an LMP, LL, or AMP message needs to indicate a failure, error codes\n> are used to indicate the reason for the error. Error codes have a size of one octet.\n\nReference: Version 5.0, Vol 2, Part D, 1","ref":"BlueHeron.ErrorCode.html"},{"type":"function","title":"BlueHeron.ErrorCode.to_atom/1","doc":"","ref":"BlueHeron.ErrorCode.html#to_atom/1"},{"type":"function","title":"BlueHeron.ErrorCode.to_code/1","doc":"","ref":"BlueHeron.ErrorCode.html#to_code/1"},{"type":"function","title":"BlueHeron.ErrorCode.to_code!/1","doc":"","ref":"BlueHeron.ErrorCode.html#to_code!/1"},{"type":"function","title":"BlueHeron.ErrorCode.to_string/1","doc":"","ref":"BlueHeron.ErrorCode.html#to_string/1"},{"type":"type","title":"BlueHeron.ErrorCode.name/0","doc":"","ref":"BlueHeron.ErrorCode.html#t:name/0"},{"type":"module","title":"BlueHeron.GATT.Characteristic","doc":"Struct that represents a GATT characteristic.","ref":"BlueHeron.GATT.Characteristic.html"},{"type":"function","title":"BlueHeron.GATT.Characteristic.new/1","doc":"Create a characteristic with fields taken from the map `args`.\n\nThe following fields are required:\n- `id`: A user-defined term to identify the characteristic. Must be unique within the device profile.\n   Can be any Erlang term.\n- `type`: The characteristic type UUID. Can be a 2- or 16-byte byte UUID. Integer.\n- `properties`: The characteristic property flags. Integer.","ref":"BlueHeron.GATT.Characteristic.html#new/1"},{"type":"function","title":"Example: - BlueHeron.GATT.Characteristic.new/1","doc":"iex> BlueHeron.GATT.Characteristic.new(%{\n    ...>   id: :fancy_key,\n    ...>   type: 0x2e0f8e717a7d4690998377626bc6b657,\n    ...>   properties: 0b00000010,\n    ...>   permissions: [:write]\n    ...> })\n    %BlueHeron.GATT.Characteristic{id: :fancy_key, type: 0x2e0f8e717a7d4690998377626bc6b657, properties: 2, permissions: [:write]}","ref":"BlueHeron.GATT.Characteristic.html#new/1-example"},{"type":"type","title":"BlueHeron.GATT.Characteristic.id/0","doc":"","ref":"BlueHeron.GATT.Characteristic.html#t:id/0"},{"type":"opaque","title":"BlueHeron.GATT.Characteristic.t/0","doc":"","ref":"BlueHeron.GATT.Characteristic.html#t:t/0"},{"type":"module","title":"BlueHeron.GATT.Characteristic.Descriptor","doc":"Struct that represents a GATT characteristic descriptor.","ref":"BlueHeron.GATT.Characteristic.Descriptor.html"},{"type":"function","title":"BlueHeron.GATT.Characteristic.Descriptor.new/1","doc":"Create a characteristic with fields taken from the map `args`.\n\nThe following fields are required:\n- `permissions`: The characteristic descriptor property flags. Integer.","ref":"BlueHeron.GATT.Characteristic.Descriptor.html#new/1"},{"type":"function","title":"Example: - BlueHeron.GATT.Characteristic.Descriptor.new/1","doc":"iex> BlueHeron.GATT.Characteristic.Descriptor.new(%{\n    ...>   value: 0x0001,\n    ...> })\n    %BlueHeron.GATT.Characteristic.Descriptor{permissions: 2, value: <<0,0>>}","ref":"BlueHeron.GATT.Characteristic.Descriptor.html#new/1-example"},{"type":"opaque","title":"BlueHeron.GATT.Characteristic.Descriptor.t/0","doc":"","ref":"BlueHeron.GATT.Characteristic.Descriptor.html#t:t/0"},{"type":"module","title":"BlueHeron.GATT.Server","doc":"A behaviour module for implementing a GATT server.\n\nThis module handles all generic aspects of the GATT protocol, including MTU\nexchange and service discovery. The callback module is invoked for a\ndescription of the GATT profile (services and characteristics), as well as\nreading and writing characteristic values.\n\nExample callback module:\n\n    defmodule MyApp.MyGattServer do\n      @behaviour BlueHeron.GATT.Server\n\n      @impl BlueHeron.GATT.Server\n      def profile() do\n        [\n          BlueHeron.GATT.Service.new(%{\n            id: :gap,\n            type: 0x1800,\n            characteristics: [\n              BlueHeron.GATT.Characteristic.new(%{\n                id: {:gap, :device_name},\n                type: 0x2A00,\n                properties: 0b0000010\n              }),\n              BlueHeron.GATT.Characteristic.new(%{\n                id: {:gap, :appearance},\n                type: 0x2A01,\n                properties: 0b0000010\n              })\n            ]\n          }),\n          BlueHeron.GATT.Service.new(%{\n            id: :my_custom_service,\n            type: 0xBB5D5975D8E4853998F51335CDFFE9A,\n            characteristics: [\n              BlueHeron.GATT.Characteristic.new(%{\n                id: {:my_custom_service, :my_custom_characteristic},\n                type: 0x1234,\n                properties: 0b0001010\n              }),\n              BlueHeron.GATT.Characteristic.new(%{\n                id: {:my_custom_service, :another_custom_characteristic},\n                type: 0xF018E00E0ECE45B09617B744833D89BA,\n                properties: 0b0001010\n              })\n            ]\n          })\n        ]\n      end\n\n      @impl BlueHeron.GATT.Server\n      def read({:gap, :device_name}) do\n        \"my-device-name\"\n      end\n\n      @impl BlueHeron.GATT.Server\n      def write({:my_custom_serivce, :my_custom_characteristic}, value) do\n        MyApp.DB.insert(:my_custom_characteristic, value)\n      end\n    end","ref":"BlueHeron.GATT.Server.html"},{"type":"function","title":"BlueHeron.GATT.Server.check_notification_mtu/2","doc":"","ref":"BlueHeron.GATT.Server.html#check_notification_mtu/2"},{"type":"function","title":"BlueHeron.GATT.Server.dump/1","doc":"","ref":"BlueHeron.GATT.Server.html#dump/1"},{"type":"opaque","title":"BlueHeron.GATT.Server.t/0","doc":"","ref":"BlueHeron.GATT.Server.html#t:t/0"},{"type":"module","title":"BlueHeron.GATT.Service","doc":"Struct that represents a GATT service.","ref":"BlueHeron.GATT.Service.html"},{"type":"function","title":"BlueHeron.GATT.Service.new/1","doc":"Create a service with fields taken from the map `args`.\n\nThe following fields are required:\n- `id`: A user-defined term to identify the service. Must be unique within the device profile.\n   Can be any Erlang term.\n- `type`: The service type UUID. Can be a 2- or 16-byte byte UUID. Integer.\n- `characteristics`: A list of characteristics.\n- `read`: a 1 arity function called when the value of a characteristic should be read.\n- `write`: a 2 arity function called when the value of a characteristic should be written.\n- `subscribe`: a 1 arity function called when the value of a characteristic's value should be indicated.\n- `unsubscribe`: a 1 arity function called when the value of a characteristic's value should stop indicating.","ref":"BlueHeron.GATT.Service.html#new/1"},{"type":"type","title":"BlueHeron.GATT.Service.id/0","doc":"","ref":"BlueHeron.GATT.Service.html#t:id/0"},{"type":"type","title":"BlueHeron.GATT.Service.read_fn/0","doc":"","ref":"BlueHeron.GATT.Service.html#t:read_fn/0"},{"type":"type","title":"BlueHeron.GATT.Service.subscribe_fn/0","doc":"","ref":"BlueHeron.GATT.Service.html#t:subscribe_fn/0"},{"type":"opaque","title":"BlueHeron.GATT.Service.t/0","doc":"","ref":"BlueHeron.GATT.Service.html#t:t/0"},{"type":"type","title":"BlueHeron.GATT.Service.write_fn/0","doc":"","ref":"BlueHeron.GATT.Service.html#t:write_fn/0"},{"type":"module","title":"BlueHeron.HCI","doc":"Volume 4 of the Bluetooth Spec","ref":"BlueHeron.HCI.html"},{"type":"module","title":"BlueHeron.HCI.ArrayedData","doc":"Serialization functions for arrayed data.\n\n> Arrayed parameters are specified using the following notation: ParameterA[i]. If more than one\n> set of arrayed parameters are specified (e.g. ParameterA[i], ParameterB[i]), then, unless\n> noted otherwise, the order of the parameters are as follows: ParameterA[0], ParameterB[0],\n> ParameterA[1], ParameterB[1], ParameterA[2], ParameterB[2], ... ParameterA[n], ParameterB[n]\n\nReference: Version 5.0, Vol 2, Part E, 5.2\n\nBoth `serialize/2` and `deserialize/4` rely on a schema to function. A schema is a keyword list\nwhere each key is a field and each value shall be:\n\n- a positive integer when denoting the size in bits of the field\n- a three-tuple when the field itself represents the length of a subsequent variable length\n  field\n- an atom when the field is variable length and a preceding field represents its length\n\nFor example if `length_data` itself was 8 bits and represented the length of `data` that would\nbe written as:\n\n```\n[\n  length_data: {:variable, :data, 8},\n  data: :length_data\n]\n```","ref":"BlueHeron.HCI.ArrayedData.html"},{"type":"function","title":"BlueHeron.HCI.ArrayedData.deserialize/4","doc":"Deserialize the binary representation of a list of structs according to `schema`.","ref":"BlueHeron.HCI.ArrayedData.html#deserialize/4"},{"type":"function","title":"BlueHeron.HCI.ArrayedData.serialize/2","doc":"Serializes a list of `structs` into their binary representation according to `schema`.","ref":"BlueHeron.HCI.ArrayedData.html#serialize/2"},{"type":"type","title":"BlueHeron.HCI.ArrayedData.field/0","doc":"","ref":"BlueHeron.HCI.ArrayedData.html#t:field/0"},{"type":"type","title":"BlueHeron.HCI.ArrayedData.field_size/0","doc":"","ref":"BlueHeron.HCI.ArrayedData.html#t:field_size/0"},{"type":"type","title":"BlueHeron.HCI.ArrayedData.schema/0","doc":"","ref":"BlueHeron.HCI.ArrayedData.html#t:schema/0"},{"type":"behaviour","title":"BlueHeron.HCI.Command","doc":"> The Link Control commands allow a Controller to control connections to other BR/EDR\n> Controllers. Some Link Control commands are used only with a BR/EDR Controller\n> whereas other Link Control commands are also used with an LE Controller.\n\nBluetooth Spec v5.2, vol 4, Part E, 7","ref":"BlueHeron.HCI.Command.html"},{"type":"macro","title":"BlueHeron.HCI.Command.defparameters/1","doc":"","ref":"BlueHeron.HCI.Command.html#defparameters/1"},{"type":"callback","title":"BlueHeron.HCI.Command.deserialize/1","doc":"","ref":"BlueHeron.HCI.Command.html#c:deserialize/1"},{"type":"callback","title":"BlueHeron.HCI.Command.deserialize_return_parameters/1","doc":"","ref":"BlueHeron.HCI.Command.html#c:deserialize_return_parameters/1"},{"type":"function","title":"BlueHeron.HCI.Command.opcode/2","doc":"Helper to create Command opcode from OCF and OGF values","ref":"BlueHeron.HCI.Command.html#opcode/2"},{"type":"callback","title":"BlueHeron.HCI.Command.serialize_return_parameters/1","doc":"","ref":"BlueHeron.HCI.Command.html#c:serialize_return_parameters/1"},{"type":"module","title":"BlueHeron.HCI.Command.ControllerAndBaseband","doc":"HCI commands for working with the controller and baseband.\n\n* OGF: `0x3`\n\n> The Controller & Baseband Commands provide access and control to various capabilities of the\n> Bluetooth hardware. These parameters provide control of BR/EDR Controllers and of the\n> capabilities of the Link Manager and Baseband in the BR/EDR Controller, the PAL in an AMP\n> Controller, and the Link Layer in an LE Controller. The Host can use these commands to modify\n> the behavior of the local Controller.\nBluetooth Spec v5","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.html"},{"type":"function","title":"BlueHeron.HCI.Command.ControllerAndBaseband.list/0","doc":"List all available controller and baseband command modules","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.html#list/0"},{"type":"module","title":"BlueHeron.HCI.Command.ControllerAndBaseband.HostBufferSize","doc":"> The HCI_Host_Buffer_Size command is used by the Host to notify the\n> Controller about the maximum size of the data portion of HCI ACL and\n> Synchronous Data packets sent from the Controller to the Host.\n\n* OGF: `0x3`\n* OCF: `0x33`\n* Opcode: `\"3\\f\"`\n\nBluetooth Spec v5.2, Vol 4, Part E, section 7.3.39","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.HostBufferSize.html"},{"type":"function","title":"BlueHeron.HCI.Command.ControllerAndBaseband.HostBufferSize.new/1","doc":"","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.HostBufferSize.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.ControllerAndBaseband.ReadLocalName","doc":"> The HCI_Read_Local_Name command provides the ability to read the stored user-\n> friendly name for the BR/EDR Controller.\n\n* OGF: `0x3`\n* OCF: `0x14`\n* Opcode: `<<20, 12>>`\n\nBluetooth Spec v5.2, Vol 4, Part E, section 7.3.12","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.ReadLocalName.html"},{"type":"function","title":"BlueHeron.HCI.Command.ControllerAndBaseband.ReadLocalName.new/1","doc":"","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.ReadLocalName.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.ControllerAndBaseband.Reset","doc":"> The HCI_Reset command will reset the Controller and the Link Manager on the\n> BR/EDR Controller or the Link Layer on an LE Controller. \n\n* OGF: `0x3`\n* OCF: `0x3`\n* Opcode: `<<3, 12>>`\n\nBluetooth Spec v5.2, Vol 4, Part E, section 7.3.2","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.Reset.html"},{"type":"function","title":"BlueHeron.HCI.Command.ControllerAndBaseband.Reset.new/1","doc":"","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.Reset.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.ControllerAndBaseband.SetControllerToHostFlowControl","doc":"> This command is used by the Host to turn flow control on or off for data and/or\n> voice sent in the direction from the Controller to the Host. \n\n* OGF: `0x3`\n* OCF: `0x31`\n* Opcode: `\"1\\f\"`\n\nBluetooth Spec v5.2, Vol 4, Part E, section 7.3.38","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.SetControllerToHostFlowControl.html"},{"type":"function","title":"BlueHeron.HCI.Command.ControllerAndBaseband.SetControllerToHostFlowControl.new/1","doc":"","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.SetControllerToHostFlowControl.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.ControllerAndBaseband.SetEventMask","doc":"> The HCI_Set_Event_Mask command is used to control which events are generated\n> by the HCI for the Host. If the bit in the Event_Mask is set to a one, then the event\n> associated with that bit will be enabled\n\n* OGF: `0x3`\n* OCF: `0x1`\n* Opcode: `<<1, 12>>`\n\nBluetooth Spec v5.2, Vol 4, Part E, section 7.3.1","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.SetEventMask.html"},{"type":"function","title":"BlueHeron.HCI.Command.ControllerAndBaseband.SetEventMask.new/1","doc":"","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.SetEventMask.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteClassOfDevice","doc":"> This command writes the value for the Class_Of_Device parameter.\n\n* OGF: `0x3`\n* OCF: `0x24`\n* Opcode: `\"$\\f\"`\n\nBluetooth Spec v5.2, Vol 4, Part E, section 7.3.26","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteClassOfDevice.html"},{"type":"function","title":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteClassOfDevice.new/1","doc":"","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteClassOfDevice.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteDefaultErroneousDataReporting","doc":"> This command writes the Erroneous_Data_Reporting parameter. \n\n* OGF: `0x3`\n* OCF: `0x5B`\n* Opcode: `\"[\\f\"`\n\nBluetooth Spec v5.2, Vol 4, Part E, section 7.3.65","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteDefaultErroneousDataReporting.html"},{"type":"function","title":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteDefaultErroneousDataReporting.new/1","doc":"","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteDefaultErroneousDataReporting.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteExtendedInquiryResponse","doc":"> The HCI_Write_Extended_Inquiry_Response command writes the extended inquiry\n> response to be sent during the extended inquiry response procedure.\n\n* OGF: `0x3`\n* OCF: `0x52`\n* Opcode: `\"R\\f\"`\n\nBluetooth Spec v5.2, Vol 4, Part E, section 7.3.56","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteExtendedInquiryResponse.html"},{"type":"function","title":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteExtendedInquiryResponse.new/1","doc":"","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteExtendedInquiryResponse.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteInquiryMode","doc":"> This command writes the Inquiry_Mode configuration parameter of the local BR/EDR\n> Controller\n\n* OGF: `0x3`\n* OCF: `0x45`\n* Opcode: `\"E\\f\"`\n\nBluetooth Spec v5.2, Vol 4, Part E, section 7.3.50","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteInquiryMode.html"},{"type":"function","title":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteInquiryMode.new/1","doc":"","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteInquiryMode.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteLEHostSupport","doc":"> The HCI_Write_LE_Host_Support command is used to set the LE Supported (Host)\n> Link Manager Protocol feature bi\n\n* OGF: `0x3`\n* OCF: `0x6D`\n* Opcode: `\"m\\f\"`\n\nBluetooth Spec v5.2, Vol 4, Part E, section 7.3.79","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteLEHostSupport.html"},{"type":"function","title":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteLEHostSupport.new/1","doc":"","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteLEHostSupport.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteLocalName","doc":"> he HCI_Write_Local_Name command provides the ability to modify the user-friendly\n> name for the BR/EDR Controller.\n\n* OGF: `0x3`\n* OCF: `0x13`\n* Opcode: `<<19, 12>>`\n\nBluetooth Spec v5.2, Vol 4, Part E, section 7.3.11","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteLocalName.html"},{"type":"function","title":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteLocalName.new/1","doc":"","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteLocalName.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.ControllerAndBaseband.WritePageTimeout","doc":"> This command writes the value for the Page_Timeout configuration parameter\n\n* OGF: `0x3`\n* OCF: `0x18`\n* Opcode: `<<24, 12>>`\n\nBluetooth Spec v5.2, Vol 4, Part E, section 7.3.16","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.WritePageTimeout.html"},{"type":"function","title":"BlueHeron.HCI.Command.ControllerAndBaseband.WritePageTimeout.new/1","doc":"","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.WritePageTimeout.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteScanEnable","doc":"> The Scan_Enable parameter controls whether or not the BR/EDR Controller will\n> periodically scan for page attempts and/or inquiry requests from other BR/EDR\n> Controllers. \n\n* OGF: `0x3`\n* OCF: `0x1A`\n* Opcode: `<<26, 12>>`\n\nBluetooth Spec v5.2, Vol 4, Part E, section 7.3.18","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteScanEnable.html"},{"type":"function","title":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteScanEnable.new/1","doc":"","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteScanEnable.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteSecureConnectionsHostSupport","doc":"> This command writes the Secure_Connections_Host_Support parameter in the BR/EDR\n> Controller.\n\n* OGF: `0x3`\n* OCF: `0x7A`\n* Opcode: `\"z\\f\"`\n\nBluetooth Spec v5.2, Vol 4, Part E, section 7.3.92","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteSecureConnectionsHostSupport.html"},{"type":"function","title":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteSecureConnectionsHostSupport.new/1","doc":"","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteSecureConnectionsHostSupport.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteSimplePairingMode","doc":"> This command enables Simple Pairing mode in the BR/EDR Controller.\n\n* OGF: `0x3`\n* OCF: `0x56`\n* Opcode: `\"V\\f\"`\n\nBluetooth Spec v5.2, Vol 4, Part E, section 7.3.59","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteSimplePairingMode.html"},{"type":"function","title":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteSimplePairingMode.new/1","doc":"","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteSimplePairingMode.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteSynchronousFlowControlEnable","doc":"> This command provides the ability to write the Synchronous_Flow_Control_Enable\n> parameter.\n\n* OGF: `0x3`\n* OCF: `0x2F`\n* Opcode: `\"/\\f\"`\n\nBluetooth Spec v5.2, Vol 4, Part E, section 7.3.37","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteSynchronousFlowControlEnable.html"},{"type":"function","title":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteSynchronousFlowControlEnable.new/1","doc":"","ref":"BlueHeron.HCI.Command.ControllerAndBaseband.WriteSynchronousFlowControlEnable.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.InformationalParameters","doc":"HCI commands for working with the informational parameters.\n\n* OGF: `0x4`\n\nThe Informational Parameters are fixed by the manufacturer of the Bluetooth\nhardware. These parameters provide information about the BR/EDR Controller and\nthe capabilities of the Link Manager and Baseband in the BR/EDR Controller and\nPAL in the AMP Controller. The host device cannot modify any of these\nparameters.\n\nBluetooth Spec v5.2, vol 4, Part E, 7.2","ref":"BlueHeron.HCI.Command.InformationalParameters.html"},{"type":"function","title":"BlueHeron.HCI.Command.InformationalParameters.list/0","doc":"List all available controller and baseband command modules","ref":"BlueHeron.HCI.Command.InformationalParameters.html#list/0"},{"type":"module","title":"BlueHeron.HCI.Command.InformationalParameters.ReadBdAddr","doc":"> On a BR/EDR Controller, this command reads the Bluetooth Controller address\n> (BD_ADDR).\n\n* OGF: `0x4`\n* OCF: `0x9`\n* Opcode: `<<9, 16>>`\n\nBluetooth Spec v5.3, Vol 4, Part E, section 7.4.6","ref":"BlueHeron.HCI.Command.InformationalParameters.ReadBdAddr.html"},{"type":"function","title":"BlueHeron.HCI.Command.InformationalParameters.ReadBdAddr.new/1","doc":"","ref":"BlueHeron.HCI.Command.InformationalParameters.ReadBdAddr.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.InformationalParameters.ReadBufferSize","doc":"> The HCI_Read_Buffer_Size command is used to read the maximum size of the data\n> portion of HCI ACL and Synchronous Data packets sent from the Host to the Controller.\n\n* OGF: `0x4`\n* OCF: `0x5`\n* Opcode: `<<5, 16>>`\n\nBluetooth Spec v5.3, Vol 4, Part E, section 7.4.5","ref":"BlueHeron.HCI.Command.InformationalParameters.ReadBufferSize.html"},{"type":"function","title":"BlueHeron.HCI.Command.InformationalParameters.ReadBufferSize.new/1","doc":"","ref":"BlueHeron.HCI.Command.InformationalParameters.ReadBufferSize.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.InformationalParameters.ReadLocalSupportedCommands","doc":"> This command reads the list of HCI commands supported for the local Controller.\n\n* OGF: `0x4`\n* OCF: `0x2`\n* Opcode: `<<2, 16>>`\n\nBluetooth Spec v5.3, Vol 4, Part E, section 7.4.2","ref":"BlueHeron.HCI.Command.InformationalParameters.ReadLocalSupportedCommands.html"},{"type":"function","title":"BlueHeron.HCI.Command.InformationalParameters.ReadLocalSupportedCommands.new/1","doc":"","ref":"BlueHeron.HCI.Command.InformationalParameters.ReadLocalSupportedCommands.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.InformationalParameters.ReadLocalVersion","doc":"> This command reads the values for the version information for the local Controller.\n\n* OGF: `0x4`\n* OCF: `0x1`\n* Opcode: `<<1, 16>>`\n\nBluetooth Spec v5.3, Vol 4, Part E, section 7.4.1","ref":"BlueHeron.HCI.Command.InformationalParameters.ReadLocalVersion.html"},{"type":"function","title":"BlueHeron.HCI.Command.InformationalParameters.ReadLocalVersion.new/1","doc":"","ref":"BlueHeron.HCI.Command.InformationalParameters.ReadLocalVersion.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.LEController","doc":"HCI commands for working with the LE Controller.\n\n* OGF: `0x8`\n\n> The LE Controller Commands provide access and control to various capabilities of the Bluetooth\n> hardware, as well as methods for the Host to affect how the Link Layer manages the piconet,\n> and controls connections.\n\nReference: Version 5.2, Vol 4, Part E, 7.8","ref":"BlueHeron.HCI.Command.LEController.html"},{"type":"function","title":"BlueHeron.HCI.Command.LEController.list/0","doc":"List all available LE Controller command modules","ref":"BlueHeron.HCI.Command.LEController.html#list/0"},{"type":"module","title":"BlueHeron.HCI.Command.LEController.CreateConnection","doc":"> The HCI_LE_Create_Connection command is used to create an ACL connection to a\n> connectable advertiser\n\nBluetooth Core Version 5.2 | Vol 4, Part E, section 7.8.12\n\n* OGF: `0x8`\n* OCF: `0xD`\n* Opcode: `\"\\r \"`","ref":"BlueHeron.HCI.Command.LEController.CreateConnection.html"},{"type":"function","title":"BlueHeron.HCI.Command.LEController.CreateConnection.new/1","doc":"","ref":"BlueHeron.HCI.Command.LEController.CreateConnection.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.LEController.CreateConnectionCancel","doc":"> The HCI_LE_Create_Connection_Cancel command is used to cancel the\n> HCI_LE_Create_Connection or HCI_LE_Extended_Create_Connection commands.\n> If no HCI_LE_Create_Connection or HCI_LE_Extended_Create_Connection command\n> is pending, then the Controller shall return the error code Command Disallowed (0x0C).\n\nBluetooth Core Version 5.2 | Vol 4, Part E, section 7.8.13\n\n* OGF: `0x8`\n* OCF: `0xE`\n* Opcode: `<<14, 32>>`","ref":"BlueHeron.HCI.Command.LEController.CreateConnectionCancel.html"},{"type":"function","title":"BlueHeron.HCI.Command.LEController.CreateConnectionCancel.new/1","doc":"","ref":"BlueHeron.HCI.Command.LEController.CreateConnectionCancel.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.LEController.LongTermKeyRequestNegativeReply","doc":"> The HCI_LE_Long_Term_Key_Request_Negative_Reply command is used to reply to\n> an HCI_LE_Long_Term_Key_Request event from the Controller if the Host cannot\n> provide a Long Term Key for this Connection_Handle.\n> This command shall only be used when the local device’s role is Peripheral.\n\nBluetooth Core Version 5.2 | Vol 4, Part E, section 7.8.26\n\n* OGF: `0x8`\n* OCF: `0x1B`\n* Opcode: `\"\\e \"`","ref":"BlueHeron.HCI.Command.LEController.LongTermKeyRequestNegativeReply.html"},{"type":"function","title":"BlueHeron.HCI.Command.LEController.LongTermKeyRequestNegativeReply.new/1","doc":"","ref":"BlueHeron.HCI.Command.LEController.LongTermKeyRequestNegativeReply.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.LEController.LongTermKeyRequestReply","doc":"> The HCI_LE_Long_Term_Key_Request_Reply command is used to reply to an\n> HCI_LE_Long_Term_Key_Request event from the Controller, and specifies the\n> Long_Term_Key parameter that shall be used for this Connection_Handle.\n> This command shall only be used when the local device’s role is Peripheral.\n\nBluetooth Core Version 5.2 | Vol 4, Part E, section 7.8.25\n\n* OGF: `0x8`\n* OCF: `0x1A`\n* Opcode: `<<26, 32>>`","ref":"BlueHeron.HCI.Command.LEController.LongTermKeyRequestReply.html"},{"type":"function","title":"BlueHeron.HCI.Command.LEController.LongTermKeyRequestReply.new/1","doc":"","ref":"BlueHeron.HCI.Command.LEController.LongTermKeyRequestReply.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.LEController.ReadBufferSizeV1","doc":"> This command is used to read the maximum size of the data portion of ACL data\n> packets and isochronous data packets sent from the Host to the Controller. The Host\n> shall fragment the data transmitted to the Controller according to these values so that\n> the HCI ACL Data packets and HCI ISO Data packets will contain data up to this size\n> (“data” includes optional fields in the HCI ISO Data packet, such as ISO_SDU_Length).\n\n\nBluetooth Core Version 5.2 | Vol 4, Part E, section 7.8.2\n\n* OGF: `0x8`\n* OCF: `0x2`\n* Opcode: `<<2, 32>>`","ref":"BlueHeron.HCI.Command.LEController.ReadBufferSizeV1.html"},{"type":"function","title":"BlueHeron.HCI.Command.LEController.ReadBufferSizeV1.new/1","doc":"","ref":"BlueHeron.HCI.Command.LEController.ReadBufferSizeV1.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.LEController.ReadLocalSupportedFeatures","doc":"> This command requests page 0 of the list of the supported LE features for the\n> Controller.\n\n\nBluetooth Core Version 5.2 | Vol 4, Part E, section 7.8.3\n\n* OGF: `0x8`\n* OCF: `0x3`\n* Opcode: `<<3, 32>>`","ref":"BlueHeron.HCI.Command.LEController.ReadLocalSupportedFeatures.html"},{"type":"function","title":"BlueHeron.HCI.Command.LEController.ReadLocalSupportedFeatures.new/1","doc":"","ref":"BlueHeron.HCI.Command.LEController.ReadLocalSupportedFeatures.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.LEController.ReadWhiteListSize","doc":"> The HCI_LE_Read_Filter_Accept_List_Size command is used to read the total number\n> of Filter Accept List entries that can be stored in the Controller.\n> Note: The number of entries that can be stored is not fixed and the Controller can\n> change it at any time (e.g. because the memory used to store the Filter Accept List can\n> also be used for other purposes).\n\nBluetooth Core Version 5.2 | Vol 4, Part E, section 7.8.14\n\n* OGF: `0x8`\n* OCF: `0xF`\n* Opcode: `<<15, 32>>`","ref":"BlueHeron.HCI.Command.LEController.ReadWhiteListSize.html"},{"type":"function","title":"BlueHeron.HCI.Command.LEController.ReadWhiteListSize.new/1","doc":"","ref":"BlueHeron.HCI.Command.LEController.ReadWhiteListSize.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.LEController.SetAdvertisingData","doc":"> The HCI_LE_Set_Advertising_Data command is used to set the data used in\n> advertising packets that have a data field.\n\nBluetooth Core Version 5.2 | Vol 4, Part E, section 7.8.7\n\n* OGF: `0x8`\n* OCF: `0x8`\n* Opcode: `\"\\b \"`","ref":"BlueHeron.HCI.Command.LEController.SetAdvertisingData.html"},{"type":"function","title":"BlueHeron.HCI.Command.LEController.SetAdvertisingData.new/1","doc":"","ref":"BlueHeron.HCI.Command.LEController.SetAdvertisingData.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.LEController.SetAdvertisingEnable","doc":"> The HCI_LE_Set_Advertising_Enable command is used to request the Controller\n> to start or stop advertising. The Controller manages the timing of advertisements\n> as per the advertising parameters given in the HCI_LE_Set_Advertising_Parameters\n> command.\n\nBluetooth Core Version 5.2 | Vol 4, Part E, section 7.8.9\n\n* OGF: `0x8`\n* OCF: `0xA`\n* Opcode: `\"\\n \"`","ref":"BlueHeron.HCI.Command.LEController.SetAdvertisingEnable.html"},{"type":"function","title":"BlueHeron.HCI.Command.LEController.SetAdvertisingEnable.new/1","doc":"","ref":"BlueHeron.HCI.Command.LEController.SetAdvertisingEnable.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.LEController.SetAdvertisingParameters","doc":"> The HCI_LE_Set_Scan_Parameters command is used to set the scan parameters.\n\nBluetooth Core Version 5.2 | Vol 4, Part E, section 7.8.10\n\n* OGF: `0x8`\n* OCF: `0x6`\n* Opcode: `<<6, 32>>`","ref":"BlueHeron.HCI.Command.LEController.SetAdvertisingParameters.html"},{"type":"function","title":"BlueHeron.HCI.Command.LEController.SetAdvertisingParameters.new/1","doc":"","ref":"BlueHeron.HCI.Command.LEController.SetAdvertisingParameters.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.LEController.SetEventMask","doc":"> The HCI_LE_Set_Event_Mask command is used to control which LE events are\n> generated by the HCI for the Host. If the bit in the LE_Event_Mask is set to a one,\n> then the event associated with that bit will be enabled. The event mask allows the Host\n> to control which events will interrupt it.\n\nBluetooth Core Version 5.2 | Vol 4, Part E, section 7.8.1\n\n* OGF: `0x8`\n* OCF: `0x8`\n* Opcode: `\"\\b \"`","ref":"BlueHeron.HCI.Command.LEController.SetEventMask.html"},{"type":"function","title":"BlueHeron.HCI.Command.LEController.SetEventMask.new/1","doc":"","ref":"BlueHeron.HCI.Command.LEController.SetEventMask.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.LEController.SetRandomAddress","doc":"> The HCI_LE_Set_Random_Address command is used by the Host to set the LE\n> Random Device Address in the Controller\n\nBluetooth Core Version 5.2 | Vol 4, Part E, section 7.8.4\n\n* OGF: `0x8`\n* OCF: `0x5`\n* Opcode: `<<5, 32>>`","ref":"BlueHeron.HCI.Command.LEController.SetRandomAddress.html"},{"type":"function","title":"BlueHeron.HCI.Command.LEController.SetRandomAddress.new/1","doc":"","ref":"BlueHeron.HCI.Command.LEController.SetRandomAddress.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.LEController.SetScanEnable","doc":"> The HCI_LE_Set_Scan_Enable command is used to start and stop scanning for legacy\n> PDUs (but not extended PDUs, even if the device supports extended advertising).\n> Scanning is used to discover advertising devices nearby.\n\nBluetooth Core Version 5.2 | Vol 4, Part E, section 7.8.11\n\n* OGF: `0x8`\n* OCF: `0xC`\n* Opcode: `\"\\f \"`","ref":"BlueHeron.HCI.Command.LEController.SetScanEnable.html"},{"type":"function","title":"BlueHeron.HCI.Command.LEController.SetScanEnable.new/1","doc":"","ref":"BlueHeron.HCI.Command.LEController.SetScanEnable.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.LEController.SetScanParameters","doc":"> The HCI_LE_Set_Scan_Parameters command is used to set the scan parameters.\n\nBluetooth Core Version 5.2 | Vol 4, Part E, section 7.8.10\n\n* OGF: `0x8`\n* OCF: `0xB`\n* Opcode: `\"\\v \"`","ref":"BlueHeron.HCI.Command.LEController.SetScanParameters.html"},{"type":"function","title":"BlueHeron.HCI.Command.LEController.SetScanParameters.new/1","doc":"","ref":"BlueHeron.HCI.Command.LEController.SetScanParameters.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.LEController.SetScanResponseData","doc":"> This command is used to provide data used in Scanning Packets that have a data field.\n\nBluetooth Core Version 5.2 | Vol 4, Part E, section 7.8.10\n\n* OGF: `0x8`\n* OCF: `0x9`\n* Opcode: `\"\\t \"`","ref":"BlueHeron.HCI.Command.LEController.SetScanResponseData.html"},{"type":"function","title":"BlueHeron.HCI.Command.LEController.SetScanResponseData.new/1","doc":"","ref":"BlueHeron.HCI.Command.LEController.SetScanResponseData.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.LinkControl","doc":"HCI commands for working with Link Control.\n\n* OGF: `0x1`\n\n> The Link Control commands allow a Controller to control connections to other BR/EDR\n> Controllers. Some Link Control commands are used only with a BR/EDR Controller\n> whereas other Link Control commands are also used with an LE Controller.\n\nReference: Version 5.2, Vol 4, Part E, 7.1","ref":"BlueHeron.HCI.Command.LinkControl.html"},{"type":"function","title":"BlueHeron.HCI.Command.LinkControl.list/0","doc":"List all available LE Controller command modules","ref":"BlueHeron.HCI.Command.LinkControl.html#list/0"},{"type":"module","title":"BlueHeron.HCI.Command.LinkControl.AuthenticationRequested","doc":"> This command is used to try to authenticate the remote device associated with\n> the specified Connection_Handle.\n\n* OGF: `0x1`\n* OCF: `0x11`\n* Opcode: `<<17, 4>>`\n\nBluetooth Spec v5.3, Vol 4, Part E, section 7.1.15","ref":"BlueHeron.HCI.Command.LinkControl.AuthenticationRequested.html"},{"type":"function","title":"BlueHeron.HCI.Command.LinkControl.AuthenticationRequested.new/1","doc":"","ref":"BlueHeron.HCI.Command.LinkControl.AuthenticationRequested.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.LinkControl.Disconnect","doc":"> The HCI_Disconnect command is used to terminate an existing connection. The\n> Connection_Handle parameter indicates which connection is to be disconnected\n\n* OGF: `0x1`\n* OCF: `0x6`\n* Opcode: `<<6, 4>>`\n\nBluetooth Spec v5.3, Vol 4, Part E, section 7.1.6","ref":"BlueHeron.HCI.Command.LinkControl.Disconnect.html"},{"type":"function","title":"BlueHeron.HCI.Command.LinkControl.Disconnect.new/1","doc":"","ref":"BlueHeron.HCI.Command.LinkControl.Disconnect.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.LinkControl.SetConnectionEncryption","doc":"> This command is used to try to authenticate the remote device associated with\n> the specified Connection_Handle.\n\n* OGF: `0x1`\n* OCF: `0x13`\n* Opcode: `<<19, 4>>`\n\nBluetooth Spec v5.3, Vol 4, Part E, section 7.1.16","ref":"BlueHeron.HCI.Command.LinkControl.SetConnectionEncryption.html"},{"type":"function","title":"BlueHeron.HCI.Command.LinkControl.SetConnectionEncryption.new/1","doc":"","ref":"BlueHeron.HCI.Command.LinkControl.SetConnectionEncryption.html#new/1"},{"type":"module","title":"BlueHeron.HCI.Command.LinkPolicy","doc":"HCI commands for working with the Link Policy.\n\n* OGF: `0x2`\n\n> The Link Policy Commands provide methods for the Host to affect\n> how the Link Manager manages the piconet. When Link Policy Commands are\n> used, the LM still controls how Bluetooth piconets and scatternets are\n> established and maintained, depending on adjustable policy parameters.\n> These policy commands modify the Link Manager behavior that can result\n> in changes to the link layer connections with Bluetooth remote devices\n\nReference: Version 5.2, Vol 4, Part E, 7.2","ref":"BlueHeron.HCI.Command.LinkPolicy.html"},{"type":"function","title":"BlueHeron.HCI.Command.LinkPolicy.list/0","doc":"List all available LE Controller command modules","ref":"BlueHeron.HCI.Command.LinkPolicy.html#list/0"},{"type":"module","title":"BlueHeron.HCI.Command.LinkPolicy.WriteDefaultLinkPolicySettings","doc":"This command writes the Default Link Policy configuration value.\n\nBluetooth Core Version 5.2 | Vol 4, Part E, section 7.2.12\n\nThe Default_Link_Policy_Settings parameter determines the initial value of the Link_Policy_Settings for all new BR/EDR connections.\n\nNote: See the Link Policy Settings configuration parameter for more information. See Section 6.18.\n\n* OGF: `0x2`\n* OCF: `0xF`\n* Opcode: `<<15, 8>>`","ref":"BlueHeron.HCI.Command.LinkPolicy.WriteDefaultLinkPolicySettings.html"},{"type":"function","title":"BlueHeron.HCI.Command.LinkPolicy.WriteDefaultLinkPolicySettings.new/1","doc":"","ref":"BlueHeron.HCI.Command.LinkPolicy.WriteDefaultLinkPolicySettings.html#new/1"},{"type":"protocol","title":"BlueHeron.HCI.CommandComplete.ReturnParameters","doc":"","ref":"BlueHeron.HCI.CommandComplete.ReturnParameters.html"},{"type":"function","title":"BlueHeron.HCI.CommandComplete.ReturnParameters.decode/1","doc":"Protocol for handling command return_parameters in CommandComplete event\n\nThis is mainly to allow us to do function generation at compile time\nfor handling this parsing for specific commands.","ref":"BlueHeron.HCI.CommandComplete.ReturnParameters.html#decode/1"},{"type":"function","title":"BlueHeron.HCI.CommandComplete.ReturnParameters.encode/1","doc":"","ref":"BlueHeron.HCI.CommandComplete.ReturnParameters.html#encode/1"},{"type":"type","title":"BlueHeron.HCI.CommandComplete.ReturnParameters.t/0","doc":"All the types that implement this protocol.","ref":"BlueHeron.HCI.CommandComplete.ReturnParameters.html#t:t/0"},{"type":"protocol","title":"BlueHeron.HCI.Deserializable","doc":"","ref":"BlueHeron.HCI.Deserializable.html"},{"type":"function","title":"BlueHeron.HCI.Deserializable.deserialize/1","doc":"Deserialize a binary into HCI data structures","ref":"BlueHeron.HCI.Deserializable.html#deserialize/1"},{"type":"type","title":"BlueHeron.HCI.Deserializable.t/0","doc":"All the types that implement this protocol.","ref":"BlueHeron.HCI.Deserializable.html#t:t/0"},{"type":"behaviour","title":"BlueHeron.HCI.Event","doc":"Handles parsing of HCI Events (opcode 0x04).\n\nnew event decoders should `use` this module, and be added to the\n`@modules` attribute.","ref":"BlueHeron.HCI.Event.html"},{"type":"function","title":"BlueHeron.HCI.Event.__indicator__/0","doc":"returns the opcode for HCI Events","ref":"BlueHeron.HCI.Event.html#__indicator__/0"},{"type":"function","title":"BlueHeron.HCI.Event.__modules__/0","doc":"returns the list of parsable modules","ref":"BlueHeron.HCI.Event.html#__modules__/0"},{"type":"macro","title":"BlueHeron.HCI.Event.defparameters/1","doc":"","ref":"BlueHeron.HCI.Event.html#defparameters/1"},{"type":"callback","title":"BlueHeron.HCI.Event.deserialize/1","doc":"","ref":"BlueHeron.HCI.Event.html#c:deserialize/1"},{"type":"module","title":"BlueHeron.HCI.Event.CommandComplete","doc":"> The Command Complete event is used by the Controller for most commands to\n> transmit return status of a command and the other event parameters that are\n> specified for the issued HCI command.\n\nReference: Version 5.2, Vol 4, Part E, 7.7.14","ref":"BlueHeron.HCI.Event.CommandComplete.html"},{"type":"function","title":"BlueHeron.HCI.Event.CommandComplete.maybe_decode_return_parameters/1","doc":"","ref":"BlueHeron.HCI.Event.CommandComplete.html#maybe_decode_return_parameters/1"},{"type":"module","title":"BlueHeron.HCI.Event.CommandStatus","doc":"The HCI_Command_Status event is used to indicate that the command described by\nthe Command_Opcode parameter has been received, and that the Controller is\ncurrently performing the task for this command.\n\nThis event is needed to provide mechanisms for asynchronous operation, which\nmakes it possible to prevent the Host from waiting for a command to finish. If\nthe command cannot begin to execute (a parameter error may have occurred, or the\ncommand may currently not be allowed), the Status event parameter will contain\nthe corresponding error code, and no complete event will follow since the\ncommand was not started. The Num_HCI_Command_Packets event parameter allows the\nController to indicate the number of HCI command packets the Host can send to\nthe Controller. If the Controller requires the Host to stop sending commands,\nthe Num_HCI_Command_Packets event parameter will be set to zero. To indicate to\nthe Host that the Controller is ready to receive HCI command packets, the\nController generates an HCI_Command_Status event with Status 0x00 and\nCommand_Opcode 0x0000 and the Num_HCI_Command_Packets event parameter set to 1\nor more. Command_Opcode 0x0000 is a special value indicating that this event is\nnot associated with a command sent by the Host. The Controller can send an\nHCI_Command_Status event with Command Opcode 0x0000 at any time to change the\nnumber of outstanding HCI command packets that the Host can send before waiting.\n\nReference: Version 5.2, Vol 4, Part E, 7.7.15","ref":"BlueHeron.HCI.Event.CommandStatus.html"},{"type":"module","title":"BlueHeron.HCI.Event.DisconnectionComplete","doc":"The HCI_Disconnection_Complete event occurs when a connection is terminated.\n\nThe status parameter indicates if the disconnection was successful or not. The\nreason parameter indicates the reason for the disconnection if the\ndisconnection was successful. If the disconnection was not successful, the\nvalue of the reason parameter shall be ignored by the Host. For example, this\ncan be the case if the Host has issued the HCI_Disconnect command and there\nwas a parameter error, or the command was not presently allowed, or a\nConnection_Handle that didn’t correspond to a connection was given.\n\nNote: When a physical link fails, one HCI_Disconnection_Complete event will be\nreturned for each logical channel on the physical link with the corresponding\nConnection_Handle as a parameter.\n\nReference: Version 5.2, Vol 4, Part E, 7.7.5","ref":"BlueHeron.HCI.Event.DisconnectionComplete.html"},{"type":"module","title":"BlueHeron.HCI.Event.EncryptionChange","doc":"The HCI_Encryption_Change event is used to indicate that the change of the\nencryption mode has been completed. The Connection_Handle event\nparameter will be a Connection_Handle for an ACL connection and is used to\nidentify the remote device.\n\nReference: Version 5.4, Vol 4, Part E, 7.7.8","ref":"BlueHeron.HCI.Event.EncryptionChange.html"},{"type":"module","title":"BlueHeron.HCI.Event.InquiryComplete","doc":"> The Inquiry Complete event indicates that the Inquiry is finished. This event contains a\n> Status parameter, which is used to indicate if the Inquiry completed successfully or if the\n> Inquiry was not completed.\n\nReference: Version 5.2, Vol 4, Part E, 7.7.1","ref":"BlueHeron.HCI.Event.InquiryComplete.html"},{"type":"module","title":"BlueHeron.HCI.Event.LEMeta","doc":"The LE Meta Event is used to encapsulate all LE Controller specific events.\n\nReference: Version 5.2, Vol 4, Part E, 7.7.65","ref":"BlueHeron.HCI.Event.LEMeta.html"},{"type":"function","title":"BlueHeron.HCI.Event.LEMeta.list/0","doc":"List all available controller and baseband command modules","ref":"BlueHeron.HCI.Event.LEMeta.html#list/0"},{"type":"type","title":"BlueHeron.HCI.Event.LEMeta.subevent_code/0","doc":"> An LE Controller uses subevent codes to transmit LE specific events from the Controller to the\n> Host. Note: The subevent code will always be the first Event Parameter (See Section 7.7.65).\n\nReference: Version 5.2, Vol 4, Part E, 5.4.4","ref":"BlueHeron.HCI.Event.LEMeta.html#t:subevent_code/0"},{"type":"module","title":"BlueHeron.HCI.Event.LEMeta.AdvertisingReport","doc":"> The LE Advertising Report event indicates that one or more Bluetooth devices have responded to\n> an active scan or have broadcast advertisements that were received during a passive scan. The\n> Controller may queue these advertising reports and send information from multiple devices in\n> one LE Advertising Report event.\n\nReference: Version 5.2, Vol 4, Part E, 7.7.65.2","ref":"BlueHeron.HCI.Event.LEMeta.AdvertisingReport.html"},{"type":"module","title":"BlueHeron.HCI.Event.LEMeta.AdvertisingReport.Device","doc":"A struct representing a single device within a LE Advertising Report.\n\n> The LE Advertising Report event indicates that one or more Bluetooth devices have responded to\n> an active scan or have broadcast advertisements that were received during a passive scan. The\n> Controller may queue these advertising reports and send information from multiple devices in\n> one LE Advertising Report event.\n>\n> This event shall only be generated if scanning was enabled using the LE Set Scan Enable\n> command. It only reports advertising events that used legacy advertising PDUs.\n\nReference: Version 5.0, Vol 2, Part E, 7.7.65.2\n\nThe `:data` field of an `BlueHeron.HCI.Event.LEMeta.AdvertisingReport.Device` struct represents AD\nStructures.\n\n> The significant part contains a sequence of AD structures. Each AD structure shall have a\n> Length field of one octet, which contains the Length value, and a Data field of Length octets.\n\nReference: Version 5.0, Vol 3, Part C, 11","ref":"BlueHeron.HCI.Event.LEMeta.AdvertisingReport.Device.html"},{"type":"function","title":"BlueHeron.HCI.Event.LEMeta.AdvertisingReport.Device.deserialize/1","doc":"Deserializes a LE Advertising Report Event.\n\n    iex> Device.deserialize(\n    ...>   <<2, 0, 1, 1, 2, 2, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 7, 6, 32, 1, 0, 0, 0, 2, 4,\n    ...>     7>>\n    ...> )\n    {:ok, [\n      %Device{\n        event_type: 0,\n        address_type: 1,\n        address: 2,\n        data: [],\n        rss: 4\n      },\n      %Device{\n        event_type: 1,\n        address_type: 2,\n        address: 5,\n        data: [{\"Service Data - 32-bit UUID\", %{uuid: 1, data: <<2>>}}],\n        rss: 7\n      }\n    ]}","ref":"BlueHeron.HCI.Event.LEMeta.AdvertisingReport.Device.html#deserialize/1"},{"type":"function","title":"BlueHeron.HCI.Event.LEMeta.AdvertisingReport.Device.deserialize_ads/1","doc":"Deserializes AD Structures.\n\n    iex> deserialize_ads(<<0xFF, 76, 2, 0x15, 1::size(168)>>)\n    {:ok,\n     {\"Manufacturer Specific Data\",\n      {\"Apple, Inc.\", {\"iBeacon\", %{major: 0, minor: 0, tx_power: 1, uuid: 0}}}}}\n\n    iex> deserialize_ads(<<0x20, 1::size(40)>>)\n    {:ok, {\"Service Data - 32-bit UUID\", %{uuid: 0, data: <<1>>}}}\n\n    iex> deserialize_ads(<<0xFF>>)\n    {:error, {\"Manufacturer Specific Data\", <<>>}}","ref":"BlueHeron.HCI.Event.LEMeta.AdvertisingReport.Device.html#deserialize_ads/1"},{"type":"function","title":"BlueHeron.HCI.Event.LEMeta.AdvertisingReport.Device.deserialize_advertising_data/2","doc":"Deserializes AD Structures into basic Bluetooth data types.\n\n    iex> deserialize_advertising_data(<<25, 255, 76, 2, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,\n    ...>   0, 0, 0, 1, 0, 1, 0, 2, 3, 6, 32, 1, 0, 0, 0, 2>>)\n    {:ok, [\n      {\"Manufacturer Specific Data\", {\"Apple, Inc.\", {\"iBeacon\", %{\n        major: 1,\n        minor: 2,\n        tx_power: 3,\n        uuid: 1\n      }}}},\n      {\"Service Data - 32-bit UUID\", %{uuid: 1, data: <<2>>}}]\n    }","ref":"BlueHeron.HCI.Event.LEMeta.AdvertisingReport.Device.html#deserialize_advertising_data/2"},{"type":"function","title":"BlueHeron.HCI.Event.LEMeta.AdvertisingReport.Device.serialize/1","doc":"Serializes a list of `BlueHeron.HCI.Event.LEMeta.AdvertisingReport` structs into a LE Advertising\nReport Event.\n\n    iex> Device.serialize([\n    ...>   %Device{\n    ...>     event_type: 0,\n    ...>     address_type: 1,\n    ...>     address: 2,\n    ...>     data: [],\n    ...>     rss: 4\n    ...>   },\n    ...>   %Device{\n    ...>     event_type: 1,\n    ...>     address_type: 2,\n    ...>     address: 5,\n    ...>     data: [{\"Service Data - 32-bit UUID\", %{uuid: 1, data: <<2>>}}],\n    ...>     rss: 7\n    ...>   }\n    ...> ])\n    {:ok,\n     <<2, 0, 1, 1, 2, 2, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 7, 6, 32, 1, 0, 0, 0, 2, 4, 7>>}","ref":"BlueHeron.HCI.Event.LEMeta.AdvertisingReport.Device.html#serialize/1"},{"type":"function","title":"BlueHeron.HCI.Event.LEMeta.AdvertisingReport.Device.serialize_advertising_data/2","doc":"Serializes basic Bluetooth data types into AD Structures.\n\n    iex> serialize_advertising_data([\n    ...>   {\"Manufacturer Specific Data\",\n    ...>     {\"Apple, Inc.\",\n    ...>       {\"iBeacon\",\n    ...>         %{\n    ...>           major: 1,\n    ...>           minor: 2,\n    ...>           tx_power: 3,\n    ...>           uuid: 1\n    ...>         }}}},\n    ...>   {\"Service Data - 32-bit UUID\", %{uuid: 1, data: <<2>>}}\n    ...> ])\n    {:ok,\n     <<25, 255, 76, 2, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 2, 3, 6, 32,\n       1, 0, 0, 0, 2>>}","ref":"BlueHeron.HCI.Event.LEMeta.AdvertisingReport.Device.html#serialize_advertising_data/2"},{"type":"function","title":"BlueHeron.HCI.Event.LEMeta.AdvertisingReport.Device.serialize_device_data/1","doc":"Serializes a `BlueHeron.HCI.Event.LEMeta.AdvertisingData.Device` structs' `:data` field into AD\nStructures.\n\n    iex> serialize_device_data(\n    ...>   %Device{\n    ...>     address: 1,\n    ...>     address_type: 2,\n    ...>     data: [\n    ...>       {\"Manufacturer Specific Data\",\n    ...>        {\"Apple, Inc.\",\n    ...>         {\"iBeacon\",\n    ...>          %{\n    ...>            major: 4,\n    ...>            minor: 5,\n    ...>            tx_power: 6,\n    ...>            uuid: 7\n    ...>          }}}},\n    ...>       {\"Service Data - 32-bit UUID\", %{uuid: 8, data: <<9>>}}\n    ...>     ],\n    ...>     event_type: 1,\n    ...>     rss: 2\n    ...>   }\n    ...> )\n    %Device{\n      address: 1,\n      address_type: 2,\n      data: <<25, 255, 76, 2, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 0, 4, 0, 5,\n              6, 6, 32, 8, 0, 0, 0, 9>>,\n      event_type: 1,\n      rss: 2\n    }","ref":"BlueHeron.HCI.Event.LEMeta.AdvertisingReport.Device.html#serialize_device_data/1"},{"type":"type","title":"BlueHeron.HCI.Event.LEMeta.AdvertisingReport.Device.t/0","doc":"","ref":"BlueHeron.HCI.Event.LEMeta.AdvertisingReport.Device.html#t:t/0"},{"type":"module","title":"BlueHeron.HCI.Event.LEMeta.ConnectionComplete","doc":"> The HCI_LE_Connection_Complete event indicates to both of the Hosts forming\n> the connection that a new connection has been created.\n\nReference: Version 5.2, Vol 4, Part E, 7.7.65.1","ref":"BlueHeron.HCI.Event.LEMeta.ConnectionComplete.html"},{"type":"module","title":"BlueHeron.HCI.Event.LEMeta.ConnectionUpdateComplete","doc":"> The HCI_LE_Connection_Update_Complete event is used to indicate that the\n> Connection Update procedure has completed.\n\nReference: Version 5.2, Vol 4, Part E, 7.7.65.3","ref":"BlueHeron.HCI.Event.LEMeta.ConnectionUpdateComplete.html"},{"type":"module","title":"BlueHeron.HCI.Event.LEMeta.EnhancedConnectionCompleteV1","doc":"> The HCI_LE_Enhanced_Connection_Complete event indicates to both of the Hosts\n> forming the connection that a new connection has been created. Upon the creation\n> of the connection a Connection_Handle shall be assigned by the Controller, and\n> passed to the Host in this event. \n\nReference: Version 5.2, Vol 4, Part E, 7.7.65.10","ref":"BlueHeron.HCI.Event.LEMeta.EnhancedConnectionCompleteV1.html"},{"type":"module","title":"BlueHeron.HCI.Event.LEMeta.LongTermKeyRequest","doc":"> The HCI_LE_Long_Term_Key_Request event indicates that the peer device, in\n> the Central role, is attempting to encrypt or re-encrypt the link and is requesting\n> the Long Term Key from the Host. (See [Vol 6] Part B, Section 5.1.3).\n\nReference: Version 5.3, Vol 4, Part E, 7.7.65.5","ref":"BlueHeron.HCI.Event.LEMeta.LongTermKeyRequest.html"},{"type":"module","title":"BlueHeron.HCI.Event.NumberOfCompletedPackets","doc":"> The HCI_Number_Of_Completed_Packets event is used by the Controller to\n> indicate to the Host how many HCI Data packets have been completed for\n> each Connection_Handle since the previous HCI_Number_Of_Completed_-\n> Packets event was sent to the Host.\n\nReference: Version 5.3, Vol 4, Part E, 7.7.19","ref":"BlueHeron.HCI.Event.NumberOfCompletedPackets.html"},{"type":"protocol","title":"BlueHeron.HCI.Serializable","doc":"","ref":"BlueHeron.HCI.Serializable.html"},{"type":"function","title":"BlueHeron.HCI.Serializable.serialize/1","doc":"Serialize an HCI data structure as a binary","ref":"BlueHeron.HCI.Serializable.html#serialize/1"},{"type":"type","title":"BlueHeron.HCI.Serializable.t/0","doc":"All the types that implement this protocol.","ref":"BlueHeron.HCI.Serializable.html#t:t/0"},{"type":"module","title":"BlueHeron.HCI.Transport","doc":"Handles sending and receiving HCI Packets","ref":"BlueHeron.HCI.Transport.html"},{"type":"function","title":"BlueHeron.HCI.Transport.buffer_acl/1","doc":"Buffer an ACL frame to be sent","ref":"BlueHeron.HCI.Transport.html#buffer_acl/1"},{"type":"function","title":"BlueHeron.HCI.Transport.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"BlueHeron.HCI.Transport.html#child_spec/1"},{"type":"function","title":"BlueHeron.HCI.Transport.get_setup_param/1","doc":"Returns the value of a setup param or an error if the transport is not ready yet.","ref":"BlueHeron.HCI.Transport.html#get_setup_param/1"},{"type":"function","title":"BlueHeron.HCI.Transport.send_hci/1","doc":"Send an HCI frame","ref":"BlueHeron.HCI.Transport.html#send_hci/1"},{"type":"type","title":"BlueHeron.HCI.Transport.command_complete/0","doc":"","ref":"BlueHeron.HCI.Transport.html#t:command_complete/0"},{"type":"type","title":"BlueHeron.HCI.Transport.command_status/0","doc":"","ref":"BlueHeron.HCI.Transport.html#t:command_status/0"},{"type":"type","title":"BlueHeron.HCI.Transport.setup_param/0","doc":"","ref":"BlueHeron.HCI.Transport.html#t:setup_param/0"},{"type":"module","title":"BlueHeron.HCI.Transport.UART","doc":"> The objective of this HCI UART Transport Layer is to make it possible to use the Bluetooth HCI\n> over a serial interface between two UARTs on the same PCB. The HCI UART Transport Layer\n> assumes that the UART communication is free from line errors.\n\nReference: Version 5.0, Vol 4, Part A, 1","ref":"BlueHeron.HCI.Transport.UART.html"},{"type":"function","title":"BlueHeron.HCI.Transport.UART.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"BlueHeron.HCI.Transport.UART.html#child_spec/1"},{"type":"function","title":"BlueHeron.HCI.Transport.UART.send_acl/2","doc":"Send binary ACL data","ref":"BlueHeron.HCI.Transport.UART.html#send_acl/2"},{"type":"function","title":"BlueHeron.HCI.Transport.UART.send_command/2","doc":"Send binary HCI data","ref":"BlueHeron.HCI.Transport.UART.html#send_command/2"},{"type":"function","title":"BlueHeron.HCI.Transport.UART.start_link/1","doc":"","ref":"BlueHeron.HCI.Transport.UART.html#start_link/1"},{"type":"module","title":"BlueHeron.HCI.Transport.UART.Framing","doc":"A framer module that defines a frame as a HCI packet.\n\nReference: Version 5.0, Vol 2, Part E, 5.4","ref":"BlueHeron.HCI.Transport.UART.Framing.html"},{"type":"function","title":"BlueHeron.HCI.Transport.UART.Framing.process/2","doc":"","ref":"BlueHeron.HCI.Transport.UART.Framing.html#process/2"},{"type":"module","title":"BlueHeron.L2Cap","doc":"> Logical Link Control and Adaptation Protocol Specification.\n\nBluetooth Spec v5.2, vol 4, Part A","ref":"BlueHeron.L2Cap.html"},{"type":"function","title":"BlueHeron.L2Cap.deserialize/1","doc":"","ref":"BlueHeron.L2Cap.html#deserialize/1"},{"type":"function","title":"BlueHeron.L2Cap.serialize/1","doc":"","ref":"BlueHeron.L2Cap.html#serialize/1"},{"type":"behaviour","title":"BlueHeron.ManufacturerDataBehaviour","doc":"Defines a behaviour that manufacturer data modules should implement.","ref":"BlueHeron.ManufacturerDataBehaviour.html"},{"type":"callback","title":"BlueHeron.ManufacturerDataBehaviour.company/0","doc":"Returns the company associated with some manufacturer data.\n\nSee: `BlueHeron.CompanyIdentifiers`","ref":"BlueHeron.ManufacturerDataBehaviour.html#c:company/0"},{"type":"module","title":"BlueHeron.Peripheral","doc":"Handles management of advertising and GATT server","ref":"BlueHeron.Peripheral.html"},{"type":"function","title":"BlueHeron.Peripheral.add_service/1","doc":"Register a new service in the GATT.","ref":"BlueHeron.Peripheral.html#add_service/1"},{"type":"function","title":"BlueHeron.Peripheral.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"BlueHeron.Peripheral.html#child_spec/1"},{"type":"function","title":"BlueHeron.Peripheral.delete_service/1","doc":"Delete a service by it's ID.","ref":"BlueHeron.Peripheral.html#delete_service/1"},{"type":"function","title":"BlueHeron.Peripheral.exchange_mtu/1","doc":"Exchange MTU with a connected central.","ref":"BlueHeron.Peripheral.html#exchange_mtu/1"},{"type":"function","title":"BlueHeron.Peripheral.notify/3","doc":"Send a notification to a connected central.","ref":"BlueHeron.Peripheral.html#notify/3"},{"type":"module","title":"BlueHeron.Registry","doc":"Handles internal message passing of BlueHeron's components","ref":"BlueHeron.Registry.html"},{"type":"function","title":"BlueHeron.Registry.subscribe/0","doc":"Subscribe to HCI events","ref":"BlueHeron.Registry.html#subscribe/0"},{"type":"module","title":"BlueHeron.SMP","doc":"A behaviour module for implementing BLE Security Manager Protocol.","ref":"BlueHeron.SMP.html"},{"type":"function","title":"BlueHeron.SMP.authenticated?/0","doc":"Returns true if the current connection is authenticated.","ref":"BlueHeron.SMP.html#authenticated?/0"},{"type":"function","title":"BlueHeron.SMP.c1/8","doc":"Bluetooth LE c1() key generation function.\n\nThe function parameters can be encoded by the following example:\n\nk is the random generated TK displayed on the device\nr is the random number generated by the SM\npreq is the data exchanged during pairing request\npres is the data exchanged during pairing response\niat is the initaitors device type (0x00 or 0x01)\nrat is the receiver device type (0x00 or 0x01)\nia is the initaitors device address\nra is the receiver device address\n\nExample from BLE specifications:\n\nk = <<0::integer-size(128)>>\nr = <<0x57, 0x83, 0xD5, 0x21, 0x56, 0xAD, 0x6F, 0x0E, 0x63, 0x88, 0x27, 0x4E, 0xC6, 0x70, 0x2E, 0xE0>>\nia = <<0xA1, 0xA2, 0xA3, 0xA4, 0xA5, 0xA6>>\nra = <<0xB1, 0xB2, 0xB3, 0xB4, 0xB5, 0xB6>>\niat = 1\nrat = 0\npres = <<0x05, 0x00, 0x08, 0x00, 0x00, 0x03, 0x02>>\npreq = <<0x07, 0x07, 0x10, 0x00, 0x00, 0x01, 0x01>>\n<<0x1E, 0x1E, 0x3F, 0xEF, 0x87, 0x89, 0x88, 0xEA, 0xD2, 0xA7, 0x4D, 0xC5, 0xBE, 0xF1, 0x3B, 0x86>> =\n  BlueHeron.SMP.Server.c1(k, r, preq, pres, iat, rat, ia, ra)","ref":"BlueHeron.SMP.html#c1/8"},{"type":"function","title":"BlueHeron.SMP.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"BlueHeron.SMP.html#child_spec/1"},{"type":"function","title":"BlueHeron.SMP.d1/3","doc":"Diversifying function d1","ref":"BlueHeron.SMP.html#d1/3"},{"type":"function","title":"BlueHeron.SMP.dm/2","doc":"Mask generation function dm","ref":"BlueHeron.SMP.html#dm/2"},{"type":"function","title":"BlueHeron.SMP.encryption_change/1","doc":"Inform the Security Manager about changes in the encryption.","ref":"BlueHeron.SMP.html#encryption_change/1"},{"type":"function","title":"BlueHeron.SMP.h6/2","doc":"Link key conversion function\n\nThe function h6 is used to convert keys of a given size from one key type to\nanother key type with equivalent strength.\nThe definition of the h6 function makes use of the hashing function AES-\nCMAC W with 128-bit key W.\n\nExmple test vectors from Bluetooth spec:\n\nw = Base.decode16!(\"EC0234A357C8AD05341010A60A397D9B\")\nkey_id = Base.decode16!(\"6C656272\")  # ASCII \"lebr\"\n\"2D9AE102E76DC91CE8D3A9E280B16399\" = Base.encode16(BlueHeron.SMP.Server.h6(w, key_id)","ref":"BlueHeron.SMP.html#h6/2"},{"type":"function","title":"BlueHeron.SMP.long_term_key_request/1","doc":"Handle Long Term Key Request event.\n\nThis function returns a Long Term Key Request Response or nil.","ref":"BlueHeron.SMP.html#long_term_key_request/1"},{"type":"function","title":"BlueHeron.SMP.s1/3","doc":"Bluetooth LE s1() key generation function.\n\nk is the random generated TK displayed on the device\nr1 is the random generated by the responding device\nr2 is the random generated by the initiating device\n\nExample from BLE specifictation:\n\nk = <<0::integer-size(128)>>\nr1 = Base.decode16!(\"000F0E0D0C0B0A091122334455667788\")\nr2 = Base.decode16!(\"010203040506070899AABBCCDDEEFF00\")\n\"9A1FE1F0E8B0F49B5B4216AE796DA062\" = Base.encode16(BlueHeron.SMP.Server.s1(k, r1, r2))","ref":"BlueHeron.SMP.html#s1/3"},{"type":"function","title":"BlueHeron.SMP.set_connection/1","doc":"Set connection information.\n\nThe information is needed for key generation.","ref":"BlueHeron.SMP.html#set_connection/1"},{"type":"module","title":"BlueHeron.SMP.DefaultIOHandler","doc":"Default IO Handler for SMP","ref":"BlueHeron.SMP.DefaultIOHandler.html"},{"type":"behaviour","title":"BlueHeron.SMP.IOHandler","doc":"Callback behavior for handling SMP IO requests","ref":"BlueHeron.SMP.IOHandler.html"},{"type":"callback","title":"BlueHeron.SMP.IOHandler.keyfile/0","doc":"returns the path to a file on the filesystem used to store encryption keys","ref":"BlueHeron.SMP.IOHandler.html#c:keyfile/0"},{"type":"callback","title":"BlueHeron.SMP.IOHandler.passkey/1","doc":"Should be used to display or otherwise print the passkey used for MITM mitigation","ref":"BlueHeron.SMP.IOHandler.html#c:passkey/1"},{"type":"callback","title":"BlueHeron.SMP.IOHandler.status_update/1","doc":"Progress callback used to handle errors or successful pairing","ref":"BlueHeron.SMP.IOHandler.html#c:status_update/1"},{"type":"type","title":"BlueHeron.SMP.IOHandler.status/0","doc":"Type of status event","ref":"BlueHeron.SMP.IOHandler.html#t:status/0"},{"type":"module","title":"BlueHeron.SMP.KeyManager","doc":"Handles storage of keys for SMP","ref":"BlueHeron.SMP.KeyManager.html"},{"type":"function","title":"BlueHeron.SMP.KeyManager.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"BlueHeron.SMP.KeyManager.html#child_spec/1"},{"type":"function","title":"BlueHeron.SMP.KeyManager.get/2","doc":"","ref":"BlueHeron.SMP.KeyManager.html#get/2"},{"type":"function","title":"BlueHeron.SMP.KeyManager.init/1","doc":"","ref":"BlueHeron.SMP.KeyManager.html#init/1"},{"type":"function","title":"BlueHeron.SMP.KeyManager.new/1","doc":"","ref":"BlueHeron.SMP.KeyManager.html#new/1"},{"type":"function","title":"BlueHeron.SMP.KeyManager.start_link/1","doc":"","ref":"BlueHeron.SMP.KeyManager.html#start_link/1"},{"type":"extras","title":"BlueHeron","doc":"# BlueHeron\n\n[![Hex version](https://img.shields.io/hexpm/v/blue_heron.svg \"Hex version\")](https://hex.pm/packages/blue_heron)\n[![API docs](https://img.shields.io/hexpm/v/blue_heron.svg?label=hexdocs \"API docs\")](https://hexdocs.pm/blue_heron/BlueHeron.html)\n[![mix test](https://github.com/blue-heron/blue_heron/actions/workflows/elixir.yaml/badge.svg)](https://github.com/blue-heron/blue_heron/actions/workflows/elixir.yaml)\n\nBlueHeron is a new Elixir Bluetooth LE Library that communicates directly with\nBluetooth modules via HCI. It is VERY much under construction, and we expect the\nuser API to change completely.\n\nOn the plus side, BlueHeron has no dependencies on Linux's `bluez` stack so if\nyou either can't use `bluez`, don't want to, or have a simple BLE use case,\nplease join us in building this out! We gather on the [Elixir Lang\nslack](https://elixir-slackin.herokuapp.com/) in the `#nerves-bluetooth`\nchannel.","ref":"readme.html"},{"type":"extras","title":"Goals - BlueHeron","doc":"BlueHeron development was started since SmartRent had a need for a very simple\nBLE interface on one of its Nerves devices.\nThe existing Elixir BLE library, [Harald](https://github.com/verypossible-labs/harald),\ndidn't have enough functionality and we made so many modifications that it no\nlonger felt like the library followed the spirit of what Harald wanted to be.\n\nOur goals here are to make a one-stop BLE library with support for the\nfollowing:\n\n* Scan for and connect to BLE peripheral devices (BlueHeron takes on the central\n  role like a smartphone)\n* GATT client support\n* Work with USB and UART-based Bluetooth modules\n* Support BLE beacons\n* BLE peripheral and GATT server support\n\nThe current focus is on filling out the central role. The API is quite unstable\nat the moment, but we're aiming for a high level API so that most users don't\nneed to become Bluetooth experts. Currently, the raw API is helping us learn and\niron out quirks quickly. See [Rationale](#Rationale) for more about why we're\ndoing building this library.\n\nIf you are interested in adding support for the other roles, please let us know\neither here or on Slack. While we're very interested in part of this library for\nwork, we're also having fun with BLE and figure that we might as well see if we\ncan hit some Nerves use cases too.","ref":"readme.html#goals"},{"type":"extras","title":"Hardware compatibility - BlueHeron","doc":"We have only tested BlueHeron with a limited number of Bluetooth adapters.\nHere's what's known:\n\n| Bluetooth module or chipset            | Connection | Works? | Firmware               | Notes\n| -------------------------------------- | ---------- | ------ | ---------------------- | -----\n| Realtek WiFi/BT combo (EDUP EP-AC1681) | USB        | Yes    | rtl_bt/rtl8822b_fw.bin | BlueHeron doesn't need to load the firmware for this one to work.\n| Cypress CYW43438 (RPi0W and RPi 3B)    | UART       | Yes    | ?                      | BlueHeron doesn't need to load the firmware for this one to work.\n| Cypress CYW43455 (RPi 3A+ and 3B+)     | UART       | No     | ?                      | Retry when #21 is fixed","ref":"readme.html#hardware-compatibility"},{"type":"extras","title":"Upgrading from 0.4.x - BlueHeron","doc":"The [0.5.0 release](https://github.com/blue-heron/blue_heron/releases/tag/v0.5.0) brought with it a bunch of updates. The most notable one\nis the addition of a supervision tree. Upgrading to this release requires a few steps.\n\n1) remove `:blue_heron_transport_uart` from your `mix.exs`. Transport code was consolidated in the 0.5 release.\n2) Update your `config.exs` with the same parameters as the Transport options. For example, on a RPI0, you would\n   change \n   ```elixir\n    config = %BlueHeronTransportUART{\n      device: \"/dev/ttyS0\",\n      uart_opts: [\n        speed: 115_200,\n      ]\n    }\n    {:ok, ctx} = BlueHeron.transport(config)\n   ```\n   into a config.exs entry: \n   ```elixir\n   config :blue_heron,\n    transport: [\n      device: \"/dev/ttyS0\",\n      speed: 115_200,\n      flow_control: :hardware\n    ]\n   ```\n3) Remove `BlueHeron.Peripheral.start_link/2` calls. The Peripheral\n   server is now started as part of BlueHeron's supervision tree.\n4) Remove any modules that have `@behaviour BlueHeron.GATT.Server`. Services\n   are now registered with `BlueHeron.Peripheral.register_service/1`. The\n   data structure remains the same.\n5) Update any calls to `BlueHeron.Peripheral.set_advertising_data/1` and similar\n   to use the new `BlueHeron.Broadcaster.set_advertising_data/1`. The data to\n   those calls is the same.","ref":"readme.html#upgrading-from-0-4-x"},{"type":"extras","title":"Getting started - BlueHeron","doc":"Below are examples of the roles supported by BlueHeron currently.","ref":"readme.html#getting-started"},{"type":"extras","title":"Broadcaster Role - BlueHeron","doc":"The simplest role to implement is a BLE Broadcaster. This is a device that doesn't *do* anything by itself,\nbut broadcasts it's information publically. A good example of this role is Apple's [iBeacon](https://en.wikipedia.org/wiki/IBeacon).\n\n```elixir\niex(1)> flags_ad = BlueHeron.AdvertisingData.flags([le_general_discoverable_mode: true, br_edr_not_supported: true])\n<<2, 1, 6>>\niex(2)> uuid = <<0xF018E00E0ECE45B09617B744833D89BA::128>>\n<<240, 24, 224, 14, 14, 206, 69, 176, 150, 23, 183, 68, 131, 61, 137, 186>>\niex(3)> major = 1\n1\niex(4)> minor = 0\n0\niex(5)> tx_power = -60\niex(6)> ibeacon = BlueHeron.AdvertisingData.IBeacon.new(uuid, major, minor, tx_power)\n<<76, 0, 2, 21, 240, 24, 224, 14, 14, 206, 69, 176, 150, 23, 183, 68, 131, 61,\n  137, 186, 0, 1, 0, 0, 196>>\niex(7)> ibeacon_ad = BlueHeron.AdvertisingData.manufacturer_specific_data(ibeacon)\n<<26, 255, 76, 0, 2, 21, 240, 24, 224, 14, 14, 206, 69, 176, 150, 23, 183, 68,\n  131, 61, 137, 186, 0, 1, 0, 0, 196>>\nBlueHeron.Broadcaster.set_advertising_data(flags_ad <> BlueHeron.AdvertisingData.manufacturer_specific_data(ibeacon))\n:ok\niex(8)> BlueHeron.Broadcaster.start_advertising()\n:ok\n```","ref":"readme.html#broadcaster-role"},{"type":"extras","title":"Peripheral - BlueHeron","doc":"A Peripheral is a Broadcaster that allows a connection via the GATT and GAP Service Discovery protocols. This allows a device\nto *do* something. To setup a Peripheral, first we need to enable the Broadcaster role so our device can be found.\n\n```elixir\n# stop advertising while we change the payload.\niex(1)> BlueHeron.Broadcaster.stop_advertising()\n:ok\n# flags will be the same as before.\niex(2)> flags_ad = BlueHeron.AdvertisingData.flags([le_general_discoverable_mode: true, br_edr_not_supported: true])\n<<2, 1, 6>>\niex(3)> short_name = \"nerves\"\n\"nerves\"\niex(4)> short_name_ad = BlueHeron.AdvertisingData.short_name(short_name)\n\"\\a\\bnerves\"\niex(5)> incomplete_list_of_service_ids = BlueHeron.AdvertisingData.incomplete_list_of_service_uuids([0xF018E00E0ECE45B09617B744833D89BA])\n<<17, 6, 186, 137, 61, 131, 68, 183, 23, 150, 176, 69, 206, 14, 14, 224, 24,\n  240>>\niex(6)> BlueHeron.Broadcaster.set_advertising_data(flags_ad <> short_name_ad <> incomplete_list_of_service_ids)\n:ok\niex(7)> BlueHeron.Broadcaster.start_advertising()\n:ok\n```\n\nThis will set the scanned name to be `nerves`. \n\nSince the AdvertisingData payload is limited to only 31 bytes, if we want to set additional information, we\ncan put it in the `ScanResponseData`. This is an additional payload that is scanned and usually cached on\nCentral devices. For example setting the long name can be done with:\n\n```elixir\n# stop advertising while we change the payload.\niex(1)> BlueHeron.Broadcaster.stop_advertising()\n:ok\n# flags will be the same as before.\niex(2)> flags_ad = BlueHeron.AdvertisingData.flags([le_general_discoverable_mode: true, br_edr_not_supported: true])\n<<2, 1, 6>>\niex(3)> long_name = \"nerves-\" <> Nerves.Runtime.serial_number()\n\"nerves-00000000b5f1bea0\"\niex(4)> long_name_ad = BlueHeron.AdvertisingData.complete_name(long_name)\n<<24, 9, 110, 101, 114, 118, 101, 115, 45, 48, 48, 48, 48, 48, 48, 48, 48, 98,\n  53, 102, 49, 98, 101, 97, 48>>\niex(5)> BlueHeron.Broadcaster.set_scan_response_data(long_name_ad)\n:ok\niex(6)> BlueHeron.Broadcaster.start_advertising()\n:ok\n```\n\nNow that the device is advertising, we need to implement the service we listed: `0xF018E00E0ECE45B09617B744833D89BA`, as well as\nimplement the `GAP` and `GATT` profiles. \n\n```elixir\niex(7)> gap_service = BlueHeron.GATT.Service.new(%{\n...(7)>   id: :gap,\n...(7)>   type: 0x1800,\n...(7)>   characteristics: [\n...(7)>     BlueHeron.GATT.Characteristic.new(%{\n...(7)>       id: {:gap, :device_name},\n...(7)>       type: 0x2A00,\n...(7)>       properties: 0b0000010\n...(7)>     }),\n...(7)>     BlueHeron.GATT.Characteristic.new(%{\n...(7)>       id: {:gap, :appearance},\n...(7)>       type: 0x2A01,\n...(7)>       properties: 0b0000010\n...(7)>     })\n...(7)>   ],\n...(7)>   read: fn \n...(7)>     {:gap, :device_name} -> \n...(7)>       \"nerves-\" <> Nerves.Runtime.serial_number()\n...(7)>     {:gap, :appearance} ->\n...(7)>       <<0x008D::little-16>>\n...(7)>   end\n...(7)> })\n%BlueHeron.GATT.Service{\n  id: :gap,\n  type: 6144,\n  characteristics: [\n    %BlueHeron.GATT.Characteristic{\n      id: {:gap, :device_name},\n      type: 10752,\n      properties: 2,\n      permissions: nil,\n      descriptor: nil,\n      handle: nil,\n      value_handle: nil,\n      descriptor_handle: nil\n    },\n    %BlueHeron.GATT.Characteristic{\n      id: {:gap, :appearance},\n      type: 10753,\n      properties: 2,\n      permissions: nil,\n      descriptor: nil,\n      handle: nil,\n      value_handle: nil,\n      descriptor_handle: nil\n    }\n  ],\n  handle: nil,\n  end_group_handle: nil,\n  read: #Function<42.39164016/1 in :erl_eval.expr/6>,\n  write: #Function<3.104805658/2 in BlueHeron.GATT.Service.default_write_callback>,\n  subscribe: #Function<5.104805658/1 in BlueHeron.GATT.Service.default_subscribe_callback>,\n  unsubscribe: #Function<7.104805658/1 in BlueHeron.GATT.Service.default_unsubscribe_callback>\n}\niex(8)> gatt_service = BlueHeron.GATT.Service.new(%{\n...(8)>   id: :gatt,\n...(8)>   type: 0x1801,\n...(8)>   characteristics: [\n...(8)>     BlueHeron.GATT.Characteristic.new(%{\n...(8)>       id: {:gatt, :service_changed}, \n...(8)>       type: 0x2A05,\n...(8)>       properties: 0b100000\n...(8)>     })\n...(8)>   ]\n...(8)> })\n%BlueHeron.GATT.Service{\n  id: :gatt,\n  type: 6145,\n  characteristics: [\n    %BlueHeron.GATT.Characteristic{\n      id: {:gatt, :service_changed},\n      type: 10757,\n      properties: 32,\n      permissions: nil,\n      descriptor: nil,\n      handle: nil,\n      value_handle: nil,\n      descriptor_handle: nil\n    }\n  ],\n  handle: nil,\n  end_group_handle: nil,\n  read: #Function<1.104805658/1 in BlueHeron.GATT.Service.default_read_callback>,\n  write: #Function<3.104805658/2 in BlueHeron.GATT.Service.default_write_callback>,\n  subscribe: #Function<5.104805658/1 in BlueHeron.GATT.Service.default_subscribe_callback>,\n  unsubscribe: #Function<7.104805658/1 in BlueHeron.GATT.Service.default_unsubscribe_callback>\n}\niex(9)> custom_service = BlueHeron.GATT.Service.new(%{\n...(9)>   id: :test,\n...(9)>   type: 0xF018E00E0ECE45B09617B744833D89BA,\n...(9)>   characteristics: [\n...(9)>     BlueHeron.GATT.Characteristic.new(%{\n...(9)>       id: {:test, :char_1},\n...(9)>       type: 0x2e0f8e717a7d4690998377626bc6b657,\n...(9)>       properties: 0b0000010,\n...(9)>       permissions: [:read_auth]\n...(9)>     }),\n...(9)>     BlueHeron.GATT.Characteristic.new(%{\n...(9)>       id: {:test, :char_2},\n...(9)>       type: 0x3e0f8e717a7d4690998377626bc6b657,\n...(9)>       properties: 0b0001000,\n...(9)>       permissions: [:write_auth]\n...(9)>     }),\n...(9)>   ],\n...(9)>   read: fn \n...(9)>     {:test, :char_1} -> \n...(9)>       \"hello, world\"\n...(9)>   end,\n...(9)>   write: fn\n...(9)>     {:test, :char_2}, value ->\n...(9)>       require Logger\n...(9)>       Logger.info(\"write #{inspect(value)}\")\n...(9)>   end\n...(9)> })\n%BlueHeron.GATT.Service{\n  id: :test,\n  type: 319143878486512296490943150958665632186,\n  characteristics: [\n    %BlueHeron.GATT.Characteristic{\n      id: {:test, :char_1},\n      type: 61225261351838855375776121692935861847,\n      properties: 2,\n      permissions: [:read_auth],\n      descriptor: nil,\n      handle: nil,\n      value_handle: nil,\n      descriptor_handle: nil\n    },\n    %BlueHeron.GATT.Characteristic{\n      id: {:test, :char_2},\n      type: 82492909284397509342237034657421375063,\n      properties: 8,\n      permissions: [:write_auth],\n      descriptor: nil,\n      handle: nil,\n      value_handle: nil,\n      descriptor_handle: nil\n    }\n  ],\n  handle: nil,\n  end_group_handle: nil,\n  read: #Function<42.39164016/1 in :erl_eval.expr/6>,\n  write: #Function<41.39164016/2 in :erl_eval.expr/6>,\n  subscribe: #Function<5.104805658/1 in BlueHeron.GATT.Service.default_subscribe_callback>,\n  unsubscribe: #Function<7.104805658/1 in BlueHeron.GATT.Service.default_unsubscribe_callback>\n}\niex(10)> BlueHeron.Peripheral.add_service(gap_service)\n:ok\niex(11)> BlueHeron.Peripheral.add_service(gatt_service)\n:ok\niex(12)> BlueHeron.Peripheral.add_service(encrypted_service)\n:ok\n```\n\nOnce completed, you should be able to connect to the `nerves` BLE device, it will do a encrypted `Bonding` procedure, and finally allow\nyou to `read` and `write` the implemented services.","ref":"readme.html#peripheral"},{"type":"extras","title":"Helpful docs - BlueHeron","doc":"* [Bluetooth Core Specification v5.2](https://www.bluetooth.org/docman/handlers/downloaddoc.ashx?doc_id=478726)","ref":"readme.html#helpful-docs"},{"type":"extras","title":"Rationale - BlueHeron","doc":"This library will likely feel like a whole lot of reinvention of the wheel for\nanyone familiar with Bluetooth stacks in embedded Linux. It took around three\nyears for one of us to get to this point of starting a new library, so it's\nworth sketching out why.\n\nThe obvious approach is to use Linux's `bluez` stack. It certainly worked, but\nwas complicated for most people to set up when using Nerves. Consequently, it\nwas hard to debug and a thankless task for anyone attempting to support Nerves\nusers. It was far easier to use `bluez` on a batteries-included OS distribution\nlike Raspbian.\n\nThe next approach was to use a smart Bluetooth module like an Adafruit Bluefruit\nmodule or a Roving Networks (now Microchip) Bluetooth module. These have an `AT`\nstyle command set for doing common Bluetooth things (for example,\nsee\n[here](https://learn.adafruit.com/introducing-adafruit-ble-bluetooth-low-energy-friend/command-mode)),\nand are fairly easy to use once you got used to the interface. Not everyone\nwanted to use these for various reasons (cost being a big one).\n\nA good alternative was to use a C Bluetooth stack that talks directly to a\nBluetooth module via UART or USB using the HCI protocol. These are\ntypically marketed towards microcontroller users, but can be made to work on\nminimal Linux configurations too. Some of the options have good documentation\nand are commercially supported.\n\nIntegrating the C stack still required work, and since our needs were so simple,\nwe simultaneously looked at an Elixir implementation. Elixir has a way of making\ndull work surprisingly enjoyable, and it's especially suited to communication\nprotocols. When the proof-of-concept started working in not much time, we\ndecided that we'd much rather spend our time in Elixir than anywhere else.\n\nWill this library have more features than `bluez`? Not even close. Will it do\nwhat we need? Yes. Will it have fewer bugs, be more robust, etc.? Don't know,\nbut its small size and few parts is easier to get our heads around and debug\nwhen issues come up. Is it fun to work on? Yes, so we got permission to\nopen-source it, so we could use it for hobby projects too.","ref":"readme.html#rationale"},{"type":"extras","title":"Debugging - BlueHeron","doc":"It can be a chore to debug Bluetooth. Errors can happen at a few different\nlayers from the baseband all the way up to the high level software. Below are\nsome useful pieces of hardware and software that can be used to debug issues\nin BlueHeron or generally snoop on BLE devices.","ref":"readme.html#debugging"},{"type":"extras","title":"Nordic Semiconductor BLE Sniffer - BlueHeron","doc":"This is a custom firmware for devboards that can be used to sniff BLE packets.\nMore info can be found on [Nordic's website](https://docs.nordicsemi.com/bundle/nrfutil_ble_sniffer_pdf/resource/nRF_Sniffer_BLE_UG_v4.0.0.pdf)\n\n* [Adafruit BLE Sniffer](https://www.adafruit.com/product/2269)\n* [Nordic nrf52840 dongle](https://www.nordicsemi.com/Products/Development-hardware/nrf52840-dongle)","ref":"readme.html#nordic-semiconductor-ble-sniffer"},{"type":"extras","title":"Support - BlueHeron","doc":"We provide best-effort support via the [Elixir Forum](https://elixirforum.com/)\nand the [#nerves-bluetooth channel on the Elixir\nSlack](https://elixir-slackin.herokuapp.com/). If you need more immediate\nsupport or feature additions, commercial support is provided by [Binary\nNoggin](https://binarynoggin.com).","ref":"readme.html#support"},{"type":"extras","title":"License - BlueHeron","doc":"The source code is released under Apache License 2.0.\n\nCheck [NOTICE](NOTICE) and [LICENSE](LICENSE) files for more information.","ref":"readme.html#license"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"v0.5.0 - Changelog","doc":"* Enhancements\n  * `:blue_heron` is now it's own application\n  * Rewrote `BlueHeron.HCI.Transport` to support the new supervision structure\n  * Enable SMP by default\n  * Persist GATT into a `PropertyTable` to allow for better error handling\n  * Creating a Peripheral is now a little simpler and supervised\n  * Added Broadcaster role\n* Depreciations\n  * Removed `BlueHeron.Context`\n  * Removed `BlueHeronTransportUART` and `BlueHeronTransportUSB`","ref":"changelog.html#v0-5-0"},{"type":"extras","title":"v0.4.2 - Changelog","doc":"* Bugfixes\n  * Fixed ACL messages not being delivered to parent process (Thanks @acadeau ❤️)","ref":"changelog.html#v0-4-2"},{"type":"extras","title":"v0.4.1 - Changelog","doc":"* Enhancements\n  * Added `set_scan_response_data` HCI command and Peripheral function\n    * This allows for an additional 31 bytes of advertising data to be used","ref":"changelog.html#v0-4-1"},{"type":"extras","title":"v0.4.0 - Changelog","doc":"* Enhancements\n  * Added initial implementation of SMP (Thanks @markushutzler ❤️)\n  * Added flow control for ACL data\n  * Added new HCI commands required for SMP\n* Bugfixes\n  * Fixed errors in GATT","ref":"changelog.html#v0-4-0"},{"type":"extras","title":"v0.3.0 - Changelog","doc":"* Enhancements\n  * Added initial implementation of GATT (Thanks @trarbr ❤️)","ref":"changelog.html#v0-3-0"},{"type":"extras","title":"v0.2.1 - Changelog","doc":"* Enhancements\n  * Added HCI commands for GATT (Thanks @trarbr ❤️)","ref":"changelog.html#v0-2-1"},{"type":"extras","title":"v0.2.0 - Changelog","doc":"* Potential breaking changes\n  There was quite a bit of internal adjustments and refactoring to cleanup\n  implementation, although no core functions were changed. You should see\n  no difference when updating but it was worth watching your implementation\n  after updating in case something was missed in the cleanup\n\n* Enhancements\n  * Add new Address module to simplify the different address interpretations\n  * Allow disabling logging to /tmp/hcidump.pklg file (Thanks @axelson!)\n  * Lots of HCI Commands added to better support default behavior (Thanks @trarbr!)\n\n* Fixes\n  * fix/workaround for the rpi3 (Thanks @axelson!)\n  * Fixed dmesg output display in govee example readme (Thanks @kevinansfield!)","ref":"changelog.html#v0-2-0"},{"type":"extras","title":"v0.1.1 - Changelog","doc":"* Bugfixes\n  * Disconnecting from an ATT client works now\n  * Reconnect now works\n  * Sending a `connection_create` cmd when a device is unavailable\n    retries now\n  * `connection_complete` event now uses the correct address\n  * Multiple ATT clients can now be started simultaneously\n  * HCI and ACL calls will now timeout rather than hang forever\n    endianness\n  * Transport now supports having multiple commands in flight\n* Enhancements\n  * Added `btsnoop` parser","ref":"changelog.html#v0-1-1"},{"type":"extras","title":"v0.1.0 - Changelog","doc":"Initial release","ref":"changelog.html#v0-1-0"},{"type":"extras","title":"Notice","doc":"LEGAL NOTICE INFORMATION\n------------------------\n\nAll the files in this distribution are copyright to the terms below.\n\n== Various .ex files\n\nFiles copied from the Harald library include the copyright information in their\nheader. It is the following:\n\nCopyright (c) 2019 Very\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.\n\n== All other files\n\nCopyright 2020 SmartRent.com, Inc.\n\nLicensed under the Apache License, Version 2.0 (the \"License\");\nyou may not use this file except in compliance with the License.\nYou may obtain a copy of the License at\n\n   https://www.apache.org/licenses/LICENSE-2.0\n\nUnless required by applicable law or agreed to in writing, software\ndistributed under the License is distributed on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\nSee the License for the specific language governing permissions and\nlimitations under the License.","ref":"notice.html"},{"type":"extras","title":"License","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   APPENDIX: How to apply the Apache License to your work.\n\n      To apply the Apache License to your work, attach the following\n      boilerplate notice, with the fields enclosed by brackets \"[]\"\n      replaced with your own identifying information. (Don't include\n      the brackets!)  The text should be enclosed in the appropriate\n      comment syntax for the file format. We also recommend that a\n      file or class name and description of purpose be included on the\n      same \"printed page\" as the copyright notice for easier\n      identification within third-party archives.\n\n   Copyright [yyyy] [name of copyright owner]\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       http://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.35.1"}}